/*
 * isdrush - load beta pictures (DOS)
 *   Copyright (C)1999 Tachibana Eriko
 */

#include <sys/dos.h>

#include "isd_header.h"


/* Function */
int
dos_beta (int fd, int frame_num, int frame_size, char* buf)
{
  IsdFrameHeader* hed = (IsdFrameHeader*) buf;

  while (--frame_num >= 0
	&& _dos_read (fd, buf, frame_size) == frame_size)
    {
      unsigned char* gvram = hed->gvram;
      unsigned long* g_data = (unsigned long*) hed->g_data;
      unsigned short y = hed->y_length;

      do
	{
	  unsigned long* p = (unsigned long*) gvram;
	  unsigned short x = hed->x_length / 2;

	  /* PC] */
	  do
	    *p++ = *g_data++;
	  while (--x);

	  gvram += hed->x_offset;
	}
      while (--y);

      if (_dos_k_keysns () && _dos_k_keyinp () == 0x1b)
	return _dos_k_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

/* EOF */
