* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _crt.s,v 1.0 1995/02/13 20:50:48 nenetto Exp $
*
		.xdef	_crtmod
		.xdef	_mask_512


* ------------------------------------------------------------
*	CRT[hύX
*
*	input	d0.b : crt mode
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_crtmod:
		movem.l	d0-d7/a0-a6,-(sp)
		lea	T_crtc(pc),a0
		mulu	#CRTC1-CRTC0,d0
		lea	(a0,d0.w),a0
		lea	$e80000,a1
		@@:	btst	#4,$e88001
		bne	@b
		moveq	#9-1,d0
		@@:	move.w	(a0)+,(a1)+
		dbra	d0,@b
		move.w	(a0)+,d0
		move.b	d0,$e80029
		tst.w	(a0)+
		beq	1f
		ori.b	#$02,$e8e007
		bra	2f
	1:	andi.b	#$fd,$e8e007
	2:	lea	$eb0810+2,a1
		move.w	(a0)+,-(a1)
		move.w	(a0)+,-(a1)
		move.w	(a0)+,-(a1)
		.rept	2
		@@:	btst	#7,$e88001		* H-SYNC
		bne	@b
		@@:	btst	#7,$e88001		* H-SYNC
		beq	@b
		.endm
		move.w	(a0)+,-(a1)
		movem.l	(sp)+,d0-d7/a0-a6
		rts

T_crtc:
*CRTCx:	.dc.w	 R0,  R1,  R2,  R3,  R4, R5,  R6,  R7, R8, R20, HRL
*	.dc.w	R20,  R6, R2+4, $ff/$25

CRTC0:	.dc.w	137,  14,  28, 124, 567,  5,  40, 552, 27, $16, 0	*31kHz,768~512
	.dc.w	$16,  40,  32, $ff		* ?
CRTC1:	.dc.w	137,  14,  24, 120, 282,  2,  16, 256, 44, $19, 1	*15kHz,768~512
	.dc.w	$19,  16,  28, $ff		* ?
CRTC2:	.dc.w	 91,   9,  17,  81, 567,  5,  40, 552, 27, $15, 0	*31kHz,512~512
	.dc.w	$15,  40,  21, $ff
CRTC3:	.dc.w	 75,   3,   5,  69, 287,  2,  16, 272, 44, $05, 0	*15kHz,512~512
	.dc.w	$05,  16,   9, $ff
CRTC4:	.dc.w	 67,   6,  12, 60,  575,  5,  40, 552, 27, $11, 1	*31kHz,384~256
	.dc.w	$11,  40,  16, $ff
CRTC5:	.dc.w	 67,   6,   9,  57, 287,  2,  16, 256, 36, $14, 1	*15kHz,384~256
	.dc.w	$14,  16,  13, $ff
CRTC6:	.dc.w	 45,   4,   6,  38, 567,  5,  40, 552, 27, $10, 0	*31kHz,256~256
	.dc.w	$10,  40,  10, $ff
CRTC7:	.dc.w	 37,   1,   0,  32, 287,  2,  16, 271, 44, $00, 0	*15kHz,256~256
	.dc.w	$00,  16,   4, $25

*CRTC8:	.dc.w   115,   8,  20, 100, 464,   7,  40, 440,  27,  $15,  0	*24kHz,640~400
*CRTC9:	.dc.w    56,   7,  10,  50, 464,   7,  40, 440,  27,  $10,  0	*24kHz,320~200
*CRTCA:	.dc.w	179,  12,  29, 157, 464,   8,  33, 457,  27,  $1e,  0	*24kHz,1024~848
*CRTCB:	.dc.w	137,  14,  28, 124, 567,   5,  40, 552,  27,  $1e,  0	*31kHz,768~1024
* ------------------------------------------------------------


* ------------------------------------------------------------
*	XNGA̗e}XN
*
*	input	d0.b : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_mask_512:
		movem.l	d0-d7/a0-a6,-(sp)
		clr.w	$e82200
		move.w	#1,$e82202
		movea.l	#$e00000+$80*512,a0
		moveq	#-1,d1
		moveq	#-1,d2
		moveq	#-1,d3
		moveq	#-1,d4
		suba.l	a1,a1
		suba.l	a2,a2
		suba.l	a3,a3
		suba.l	a4,a4
		move.w	#512-1,d7
		1:	lea	-32(a0),a0
			movem.l	d1-d4,-(a0)
			movem.l	a1-a4,-(a0)
			movem.l	a1-a4,-(a0)
			movem.l	a1-a4,-(a0)
			movem.l	a1-a4,-(a0)
			movem.l	d1-d4,-(a0)
		dbra	d7,1b
		movem.l	(sp)+,d0-d7/a0-a6
		rts
* ------------------------------------------------------------


		.end
