* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _palet.s,v 1.0 1995/02/13 20:50:49 nenetto Exp $
*
		.xdef	_mix_palet
		.xdef	_mix_palet_tx
		.xdef	_trans_palet
		.xdef	_trans_palet_tx


* ------------------------------------------------------------
*	pbg̓]
*
*	input	d0.l : source palet address
*		d1.l : distination palet address
*		d7.l : ----
*	output	d7.l : ----
*
_trans_palet:
		movem.l	d0-d7/a0-a6,-(sp)
		movea.l	d0,a0
		movea.l	d1,a1
		moveq	#256/8-1,d7
		@@:	move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
		dbra	d7,@b
		movem.l	(sp)+,d0-d7/a0-a6
		rts


_trans_palet_tx:
		movem.l	d0-d7/a0-a6,-(sp)
		movea.l	d0,a0
		movea.l	d1,a1
		moveq	#16/4-1,d7
		@@:	move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
		dbra	d7,@b
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	OtBbNpbg̍
*
*	input	d0.l : source palet address
*		d1.l : distination palet address
*		d7.l : mixture
*	output	d7.l : ----
*
_mix_palet:
		movem.l	d0-d7/a0-a6,-(sp)
		andi.w	#$ff,d7
		move.l	#256,d6
		sub.l	d7,d6
		
		movea.l	d0,a0
		movea.l	d1,a1
		movea.l	#$e82000,a2
		move.w	#256-1,d5
		@@:	move.w	(a0)+,d0
			move.w	(a1)+,d1
			 bsr	_mix
			move.w	d0,(a2)+
		dbra	d5,@b
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	eLXgpbg̍
*
*	input	d0.l : source palet address
*		d1.l : distination palet address
*		d7.l : palet num*$100 + mixture
*	output	d7.l : ----
*
_mix_palet_tx:
		movem.l	d0-d7/a0-a6,-(sp)
		move.w	d7,d2
		andi.w	#$ff,d7
		move.l	#256,d6
		sub.l	d7,d6
		
		movea.l	d0,a0
		movea.l	d1,a1
		movea.l	#$e82200,a2
		andi.w	#$0f00,d2
		lsr.w	#3,d2
		adda.w	d2,a2
		moveq	#16-1,d5
		@@:	move.w	(a0)+,d0
			move.w	(a1)+,d1
			 bsr	_mix
			move.w	d0,(a2)+
		dbra	d5,@b
		movem.l	(sp)+,d0-d7/a0-a6
		rts


	_mix:
		movem.l	d1-d4,-(sp)
		btst	#0,d0
		bne	@f

		move.w	d0,d2
		move.w	d1,d3
		lsr.w	#1,d0
		lsr.w	#1,d1
		andi.w	#%11111,d0
		andi.w	#%11111,d1
		mulu	d6,d0
		mulu	d7,d1
		add.w	d1,d0
		lsr.w	#8-1,d0
		andi.w	#%11111_0,d0
		move.w	d0,d4

		move.w	d2,d0
		move.w	d3,d1
		lsr.w	#6,d0
		lsr.w	#6,d1
		andi.w	#%11111,d0
		andi.w	#%11111,d1
		mulu	d6,d0
		mulu	d7,d1
		add.w	d1,d0
		lsr.w	#8-6,d0
		andi.w	#%11111_00000_0,d0
		or.w	d0,d4

		move.w	d2,d0
		move.w	d3,d1
		rol.w	#5,d0
		rol.w	#5,d1
		andi.w	#%11111,d0
		andi.w	#%11111,d1
		mulu	d6,d0
		mulu	d7,d1
		add.w	d1,d0
		lsl.w	#3,d0
		andi.w	#%11111_00000_00000_0,d0
		or.w	d4,d0

	@@:	movem.l	(sp)+,d1-d4
		rts
* ------------------------------------------------------------


		.end
