******************************************************************
**								**
**		.xvd easy Frame Writer 2	ver0.20		**
**								**
**						by ӂȂۂ	**
**								**
**					since May 31 1997	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	FEFUNC.H
	.include	CONST.H

	.cpu	68000

	.offset	0

SSP_SAVE::		.ds.l	1

MAGIC_HEADER::		.ds.b	4
DATA_AUTHOR::		.ds.b	32
SUB_TITLE::		.ds.b	32
TITLE::			.ds.b	64
END_MARKER::		.ds.b	4
FORMAT_REVISION::	.ds.b	4
DATA_OFFSET::		.ds.b	4
HEADER_OFFSET::		.ds.b	4
FRAME_NUMBER::		.ds.b	4
X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ASPECT_RATIO::		.ds.b	4
IMAGE_TYPE::		.ds.b	4
BASE_TIME_UNIT::	.ds.b	4
FRAME_RATE::		.ds.b	4
PCM_TYPE::		.ds.b	4
PCM_CHANNEL::		.ds.b	4
PCM_FREQENCY::		.ds.b	4
PCM_BLOCK_SIZE::	.ds.b	4
POSTER_DATA::		.ds.b	4

ON_GET_NUMBER::		.ds.l	1			*-fn
ON_SPACE_NUMBER::	.ds.w	1			*-f ,n
NUMBER_TEMP::		.ds.b	4			*-a,-f temp
ON_X_NUMBER::		.ds.w	1			*-a X
ON_Y_NUMBER::		.ds.w	1			*-a  ,Y
POSTER_FLAG::		.ds.w	1			*-f nothing
OPTION_FLAG::		.ds.w	1			*-a & -f
IMAGE_SIZE		.ds.l	1			*1 frame size
X_LOOP::		.ds.w	1			*How much X
Y_LOOP::		.ds.w	1			*         Y
FILE_NAME::		.ds.b	256
WORK_SIZE::


	.text
	.even

	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,a1
	lea.l	(16,a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

	lea.l	WORK(pc),a6

	moveq.l	#0,d0
	move.w	d0,ON_GET_NUMBER(a6)
	move.w	d0,ON_SPACE_NUMBER(a6)
	move.w	d0,ON_X_NUMBER(a6)
	move.w	d0,ON_Y_NUMBER(a6)
	move.w	d0,POSTER_FLAG(a6)
	move.w	d0,OPTION_FLAG(a6)

**********************************************************
**		Comand Line Option Check		**
**********************************************************

C_CHECK::
	addq.l	#1,a2
	bsr	SKIPSP				*Xy[XXLbv
	tst.b	(a2)				*邩H
	beq	USAGE				*Ȃ USAGE

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK
	bra	GETARG				*t@C

OP_CHECK::
	addq.l	#1,a2				*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0			*ꕶo
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#"F",d0
	beq	ON_FRAME_NUMBER_GET
	cmpi.b	#"A",d0
	beq	ABSOLUTE_NUMBER_GET
	cmpi.b	#"S",d0
	beq	ON_SPACE_NUMBER_GET
	bra	C_CHECK

ON_FRAME_NUMBER_GET::
	move.w	#1,POSTER_FLAG(a6)
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_FRAME_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_FRAME_NUMBER1		*-f ̎
	cmpi.b	#TAB,(a2)
	beq	GET_FRAME_NUMBER1		*-f ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_FRAME_NUMBER0

GET_FRAME_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#$0000_FFFF,d2
	bgt	OVER_FLOW_FRAME
	move.w	d2,ON_GET_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	bra	C_CHECK

ON_SPACE_NUMBER_GET
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_SPACE_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_SPACE_NUMBER1
	cmpi.b	#TAB,(a2)
	beq	GET_SPACE_NUMBER1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_SPACE_NUMBER0

GET_SPACE_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	move.w	d2,ON_SPACE_NUMBER(a6)
	add.w	#$0001,OPTION_FLAG(a6)
	bra	C_CHECK


ABSOLUTE_NUMBER_GET::
	add.w	#$0010,OPTION_FLAG(a6)
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_X_NUMBER0::
	cmpi.b	#',',(a2)
	beq	GET_X_NUMBER1
	cmpi.b	#SPACE,(a2)
	beq	IN_NUMBER_ERR
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_X_NUMBER0

GET_X_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_X_NUMBER
	move.w	d2,ON_X_NUMBER(a6)

	cmpi.b	#SPACE,(a2)
	beq	C_CHECK				*-a ̎

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	addq.l	#1,a2

GET_Y_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_Y_NUMBER1
	cmpi.b	#TAB,(a2)
	beq	GET_Y_NUMBER1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_Y_NUMBER0

GET_Y_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_Y_NUMBER
	move.l	d2,ON_Y_NUMBER(a6)
	bra	C_CHECK

GETARG::
	lea.l	FILE_NAME(a6),a0

GETARG0::
	tst.b	(a2)				*̏I[R[hH
	beq	GETARG1

	cmpi.b	#SPACE,(a2)
	beq	GETARG1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GETARG1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ

	bra	GETARG0

GETARG1::
	clr.b	(a0)				*I[R[h

**********************************************************
**			Option Check			**
**********************************************************

	cmpi.w	#$0011,OPTION_FLAG(a6)
	beq	A_F_ERROR			*OptionĂ

**********************************************************
**		READ .xvdFILE's HEADER			**
**********************************************************

READ_FILE::
	move.w	#2,-(sp)			*READ/WRITE
	pea.l	FILE_NAME(a6)			*t@C
	DOS	_OPEN				*open
	addq.l	#6,sp

		move.w	d0,a5
		bmi	OPEN_ERROR

	move.l	#192,-(sp)			*Poster_Data܂ł̃wb_ől
	pea.l	MAGIC_HEADER(a6)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

**********************************************************
**			XVD Check			**
**********************************************************

	cmpi.l	#'XVDF',MAGIC_HEADER(a6)
	bne	NOT_XVDDATA

	move.l	FRAME_NUMBER(a6),d0
	subq.l	#1,d0
	cmp.w	ON_GET_NUMBER(a6),d0

	moveq.l	#1,d0
	add.w	ON_GET_NUMBER(a6),d0
	cmp.l	FRAME_NUMBER(a6),d0
	bhi	NUMBER_OVER

	cmpi.l	#$0002_0000,FORMAT_REVISION(a6)
	bne	NOT_REV200

	tst.l	IMAGE_TYPE(a6)
	bne	NOT_IMAGE_TYPE0

	move.l	X_LENGTH(a6),d1
	move.w	ON_X_NUMBER(a6),d0
	add.w	d0,d1
	cmpi.l	#512,d1
	bgt	OVER_X_NUMBER

	move.l	Y_LENGTH(a6),d1
	move.w	ON_Y_NUMBER(a6),d0
	add.w	d0,d1
	cmpi.l	#512,d1
	bgt	OVER_Y_NUMBER

	move.w	X_LENGTH+2(a6),d0
	move.w	Y_LENGTH+2(a6),d1
	mulu.w	d0,d1
	add.l	d1,d1
	move.l	d1,IMAGE_SIZE(a6)

**********************************************************
**			To GV-RAM			**
**********************************************************

ON_SPACE_NUMBER_CHECK::
	tst.w	ON_SPACE_NUMBER(a6)
	beq	G_RAM_READ

HOW_MANY_IMAGE::					*\`FbN
	move.w	X_LENGTH+2(a6),d0
	move.w	d0,d1
	moveq.l	#0,d7
@@:
		add.w	d1,d0
		addq.l	#1,d7
		cmpi.w	#512,d0
		ble	@b

	move.w	d7,X_LOOP(a6)			*w։\ł邩

	move.w	Y_LENGTH+2(a6),d0
	move.w	d0,d1
	moveq.l	#0,d6
@@:
		add.w	d1,d0
		addq.l	#1,d6
		cmpi.w	#512,d0
		ble	@b

	move.w	d6,Y_LOOP(a6)			*x։\ł邩
	move.w	d7,d4
	mulu.w	d6,d7
						*d7ɕ\\t[

	move.w	ON_SPACE_NUMBER(a6),d0
	cmp.w	d0,d7
	blt	ON_SPACE_NUM_ERROR

	moveq.l	#0,d7				*
@@:
	cmp.w	d4,d0				* O  P  :y=0
	blt	1F				* Q  R  :y=1
	sub.w	d4,d0				* S  T  :y=2
	addq.l	#1,d7				* U  V  :y=3
	bra	@B				* x=0 x=1
						*d7:y,d0:x
1:
	move.w	X_LENGTH+2(a6),d1
	mulu.w	d1,d0
	move.w	Y_LENGTH+2(a6),d2
	mulu.w	d2,d7

	move.w	d0,ON_X_NUMBER(a6)
	move.w	d7,ON_Y_NUMBER(a6)

G_RAM_READ::
	move.l	IMAGE_SIZE(a6),-(sp)		*image
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,a4
		bmi	MALLOC_ERROR

		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE		* sspҔ
		addq.l	#4,sp

	move.l	a4,a0
	lea.l	$00C0_0000,a1

	moveq.l	#0,d0
	move.w	ON_Y_NUMBER(a6),d0		*
	lsl.l	#8,d0				*
	lsl.l	#2,d0				* x1024
	move.w	ON_X_NUMBER(a6),d3
	add.w	d3,d0
	add.w	d3,d0
	add.l	d0,a1

	move.w	X_LENGTH+2(a6),d4
	move.l	#512,d3
	sub.w	d4,d3
	add.w	d3,d3				*d3:1 LINEƂYɑaddres

	move.w	Y_LENGTH+2(a6),d2
	subq.l	#1,d2

Y_READ_LOOP::
	move.w	X_LENGTH+2(a6),d1
	lsr.w	#1,d1
	subq.l	#1,d1

X_READ_LOOP::
		move.l	(a1)+,(a0)+
		dbra	d1,X_READ_LOOP

	add.l	d3,a1
	dbra	d2,Y_READ_LOOP

		move.l	SSP_SAVE(a6),-(sp)	*
		DOS	_SUPER			* [U[[h
		addq.l	#4,sp			*

		tst.w	POSTER_FLAG(a6)		*|X^[p
		bne	XVDFILE_WRITE
		move.l	#192,d1
		bra	XVDDATA_SEEK

XVDFILE_WRITE::
	moveq.l	#0,d2
	move.w	ON_GET_NUMBER(a6),d0
	beq	ZERO_FRAME

	move.l	IMAGE_SIZE(a6),d1
	add.l	PCM_BLOCK_SIZE(a6),d1
	subq.l	#1,d0
@@:
	add.l	d1,d2
	dbra	d0,@B
						*d1:΂
ZERO_FRAME::
	add.l	DATA_OFFSET(a6),d2		*0frame ܂ł offset

XVDDATA_SEEK::
	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d2,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	IMAGE_SIZE(a6),-(sp)
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WRITE_ERROR

	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************

GET_NUMBER1:
	moveq.l	#0,d0
	moveq.l	#0,d2
	move.l	d7,d5
	subq.l	#1,d5

	subq.l	#2,d7		*dbrap-2
	move.l	d7,d6
1:
	move.l	d6,d7
	move.b	(a0)+,d0
		cmpi.b	#'0',d0			*0`9AA`ZȊO͒e
		bcs	IN_NUMBER_ERR		*
		cmpi.b	#'9'+1,d0		*
		bcc	IN_NUMBER_ERR		*
		subi.b	#$30,d0			*𐔎ɂ

		cmpi.l	#-1,d7
		ble	GET_NUMBER3
2:
	move.l	d0,d1			*d0=d1
	add.l	d1,d1			*d1=x2
	lsl.l	#3,d0			*d0=x8
	add.l	d1,d0			*d0=x10
	dbra	d7,2B

GET_NUMBER3::
	add.l	d0,d2
	moveq.l	#0,d0
	subq.l	#1,d6
	dbra	d5,1B
	rts


SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

**********************************************************
**			Error Routine			**
**********************************************************

USAGE::
	pea.l	USAGE_MSG(pc)
	bra	DISP_ABORT


NOT_XVDDATA::
	pea.l	NOT_XVDDATA_MSG(pc)
	bra	DISP_ABORT

NOT_REV200::
	pea.l	NOT_REV200_MSG(pc)
	bra	DISP_ABORT

NOT_IMAGE_TYPE0::
	pea.l	NOT_IMAGE_TYPE0_MSG(pc)
	bra	DISP_ABORT


IN_NUMBER_ERR::
	pea.l	IN_NUMBER_ERR_MSG(pc)
	bra	DISP_ABORT

NUMBER_OVER::
	pea.l	NUMBER_OVER_MSG(pc)
	bra	DISP_ABORT

OVER_FLOW_FRAME::
	pea.l	OVER_FLOW_FRAME_MSG(pc)
	bra	DISP_ABORT

OVER_X_NUMBER::
	pea.l	OVER_X_NUMBER_MSG(pc)
	bra	DISP_ABORT

OVER_Y_NUMBER::
	pea.l	OVER_Y_NUMBER_MSG(pc)
	bra	DISP_ABORT

A_F_ERROR::
	pea.l	A_F_NUMBER_MSG(pc)
	bra	DISP_ABORT

ON_SPACE_NUM_ERROR::
	pea.l	ON_SPACE_NUM_ERROR_MSG(pc)
	bra	DISP_ABORT

**********************************************************
**			DOS CALL ERROR			**
**********************************************************

OPEN_ERROR::
	pea.l	OPEN_ERR_MSG(pc)
	bra	DISP_ABORT

MALLOC_ERROR::
	pea.l	MALLOC_ERROR_MSG(pc)
	bra	DISP_ABORT

SEEK_ERROR::
	pea.l	SEEK_ERR_MSG(pc)
	bra	DISP_ABORT

READ_ERROR::
	pea.l	READ_ERR_MSG(pc)
	bra	DISP_ABORT

WRITE_ERROR::
	pea.l	WRITE_ERROR_MSG(pc)
*	bra	DISP_ABORT

DISP_ABORT::
	DOS	_PRINT			*$FF09
	addq.l	#4,sp

END::
	DOS	_EXIT


	.data
	.even

**********************************************************
**			DATA ARIA			**
**********************************************************

USAGE_MSG::	.dc.b	'.xvd Easy Frame Writer 2 ver0.20',CR,LF
		.dc.b	'		Programed by ӂȂۂ Mar 25 1998',CR,LF
		.dc.b	CR,LF
		.dc.b	'usage : xvdfw2 <option> xvdfile',CR,LF
		.dc.b	'option: -f[num] : num = frame number (0n65535)',CR,LF
		.dc.b	'      : -a[x,y] : x,y = write point',CR,LF
		.dc.b	'      : -s[num] : num = write space',CR,LF,0

OPEN_ERR_MSG::		.dc.b	'DOS _OPEN Error!',CR,LF,0
MALLOC_ERROR_MSG::	.dc.b	'DOS _MALLOC Error!',CR,LF,0
SEEK_ERR_MSG::		.dc.b	'DOS _SEEK Error!',CR,LF,0
READ_ERR_MSG::		.dc.b	'DOS _READ Error!',CR,LF,0
WRITE_ERROR_MSG::	.dc.b	'DOS _WRITE Error!',CR,LF,0

NOT_XVDDATA_MSG::	.dc.b	'This File is not XVDfile.',CR,LF,0
NOT_REV200_MSG::	.dc.b	'This File is not rev2.00.',CR,LF,0
NOT_IMAGE_TYPE0_MSG::	.dc.b	'This File is not Type 0.',CR,LF,0

IN_NUMBER_ERR_MSG::	.dc.b	'Option Number Error!',CR,LF,0
NUMBER_OVER_MSG::	.dc.b	'Frame Number is Over!',CR,LF,0
OVER_FLOW_FRAME_MSG::	.dc.b	'Over Frame: -f[n] : 0n65536',CR,LF,0 
OVER_X_NUMBER_MSG::	.dc.b	'Over X Number: 0x+X_length512',CR,LF,0
OVER_Y_NUMBER_MSG::	.dc.b	'Over Y Number: 0y+Y_Length512',CR,LF,0
A_F_NUMBER_MSG::	.dc.b	'Dont use [write space] and [write point] at the same time!',CR,LF,0
ON_SPACE_NUM_ERROR_MSG::.dc.b	'Over Space Number!',CR,LF,0


**********************************************************
**			BSS ARIA			**
**********************************************************

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
