******************************************************************
**								**
**		xvdcat	ver0.10					**
**								**
**						by ӂȂۂ	**
**								**
**					since June 26 1999	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	CONST.H


Version::	.reg	'0.10'
Date::		.reg	'June 27 1999'
Author::	.reg	'FunaPon'


	.cpu	68000

	.offset	0

MAGIC_HEADER::		.ds.b	4
DATA_AUTHOR::		.ds.b	32
SUB_TITLE::		.ds.b	32
TITLE::			.ds.b	64
END_MARKER::		.ds.b	4
FORMAT_REVISION::	.ds.b	4
DATA_OFFSET::		.ds.b	4
HEADER_OFFSET::		.ds.b	4
FRAME_NUMBER::		.ds.b	4
X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ASPECT_RATIO::		.ds.b	4
IMAGE_TYPE::		.ds.b	4
BASE_TIME_UNIT::	.ds.b	4
FRAME_RATE::		.ds.b	4
PCM_TYPE::		.ds.b	4
PCM_CHANNEL::		.ds.b	4
PCM_FREQENCY::		.ds.b	4
PCM_BLOCK_SIZE::	.ds.b	4
FileHundle::		.ds.w	1

inputStartNumber::	.ds.w	1
inputEndNumber::	.ds.w	1
WriteFrameNumber::	.ds.w	1
pImageSizeTable::	.ds.l	1
pPcmSizeTable::		.ds.l	1
MaxMermorySize::	.ds.l	1

FileName::		.ds.b	256
XVD_WORK_SIZE::


	.offset	0

priorityFlag::		.ds.w	1
FrameNumber::		.ds.w	1
ImageSize::		.ds.l	1
pWriteData::		.ds.l	1
ImageDependDataSize::	.ds.l	1	*ԂςȂ
PcmDependDataSize::	.ds.l	1	*
CommentBlockSize::	.ds.l	1	*
pImageDependData::	.ds.l	1	*
pPcmDependData::	.ds.l	1	*
CommentBlock::		.ds.l	1	*
WORK_SIZE::


	.text
	.even


	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,a1

	lea.l	16(a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

******************************************************************
**			const figure set			**
******************************************************************

	pea.l	TitleMes(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	WORK(pc),a6

	move.l	a6,a0
	move.w	#WORKend-XVDInput1,d0
	subq.w	#1,d0
@@:
	clr.b	(a0)+
	dbra	d0,@B

******************************************************************
**			option check				**
******************************************************************

SwitchCheck:
	tst.b	(a2)+
	bne	@f
	pea.l	USAGE(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT
@@:
	move.b	(a2)+,d0
	cmpi.b	#' ',d0
	beq	@b
	cmpi.b	#'-',d0
	bne	GetFileName

	bsr	SetOption
	beq	NextCommand

	pea.l	NoOptionMes(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT

NextCommand:
	tst.b	(a2)
	bne	@b
	pea.l	NoFileMes(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT

GetFileName:
	subq.l	#1,a2
	lea.l	XVDInput1(pc),a5
	lea.l	FileName(a5),a1
	bsr	GetStrings

	lea.l	XVDInput2(pc),a5
	lea.l	FileName(a5),a1
	bsr	GetStrings

	lea.l	XVDOutput(pc),a5
	lea.l	FileName(a5),a1
	bsr	GetStrings

******************************************************************
**			Header					**
******************************************************************

	lea.l	XVDInput1(pc),a5
	bsr	HeaderRead
	bsr	DataCheck
	moveq.l	#0,d0
	move.w	inputEndNumber(a5),d0
	sub.w	inputStartNumber(a5),d0
	addq.w	#1,d0
	move.w	d0,WriteFrameNumber(a5)
	move.l	d0,d6

	lea.l	XVDInput2(pc),a5
	bsr	HeaderRead
	bsr	DataCheck
	moveq.l	#0,d0
	move.w	inputEndNumber(a5),d0
	sub.w	inputStartNumber(a5),d0
	addq.w	#1,d0
	move.w	d0,WriteFrameNumber(a5)

	add.l	d6,d0
	cmpi.l	#$0000_ffff,d0
	bhi	OverFlowError
	move.w	d0,FrameNumber(a6)

	lea.l	XVDInput1(pc),a4
	lea.l	XVDInput2(pc),a5

	lea.l	X_LENGTH(a4),a0
	lea.l	X_LENGTH(a5),a1
	moveq.l	#10-1,d0
@@:
	cmp.l	(a0)+,(a1)+
	bne	NotMatchHeader
	dbra	d0,@B

	move.w	X_LENGTH+2(a5),d0
	move.w	Y_LENGTH+2(a5),d1
	mulu.w	d1,d0
	add.l	d0,d0
	move.l	d0,ImageSize(a6)

******************************************************************
**			Header Make				**
******************************************************************

	lea.l	XVDInput1(pc),a5
	tst.w	priorityFlag(a6)
	beq	@F
	lea.l	XVDInput2(pc),a5
@@:
	lea.l	MAGIC_HEADER(a5),a0
	lea.l	XVDOutput(pc),a4
	lea.l	MAGIC_HEADER(a4),a1
	moveq.l	#192/4,d0
	subq.w	#1,d0
@@:
	move.l	(a0)+,(a1)+			*Header Copy
	dbra	d0,@B

	move.w	FrameNumber(a6),FRAME_NUMBER+2(a4)

	move.w	#$0020,-(sp)
	pea.l	FileName(a4)
	DOS	_NEWFILE			*$FF8B
	addq.l	#6,sp

		move.w	d0,FileHundle(a4)
		bmi	NewfileError

	move.l	#192,-(sp)
	pea.l	MAGIC_HEADER(a4)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

******************************************************************
**			Poster Write				**
******************************************************************

	move.l	ImageSize(a6),-(sp)
	DOS	_MALLOC
	addq.l	#2,sp

		tst.l	d0
		bmi	MallocError

	move.l	d0,a0

	move.w	#0,-(sp)			*擪
	move.l	#192,-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	ImageSize(a6),-(sp)
	move.l	a0,-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.l	ImageSize(a6),-(sp)		* poster
	move.l	a0,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	move.l	a0,-(sp)
	DOS	_MFREE			*$ff49
	addq.l	#4,sp

******************************************************************
**			Data Copy				**
******************************************************************

	move.l	#$00ff_ffff,-(sp)	*24bit
	DOS	_MALLOC			*$FF48
	addq.l	#4,sp
	andi.l	#$00ff_ffff,d0		*d0:mۂłő̃

	move.l	d0,MaxMermorySize(a6)

	move.l	d0,-(sp)
	DOS	_MALLOC			*$FF48
	addq.l	#4,sp

		tst.l	d0
		bmi	MallocError

	move.l	d0,pWriteData(a6)

	lea.l	XVDInput1(pc),a5
	bsr	StartSeek
	bsr	DataWrite

	lea.l	XVDInput2(pc),a5
	bsr	StartSeek
	bsr	DataWrite

******************************************************************
**			Headr Write				**
******************************************************************

	move.w	#1,-(sp)			*I[
	move.l	#0,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

	move.l	d0,HEADER_OFFSET(a4)

	move.w	#0,-(sp)			*擪
	move.l	#HEADER_OFFSET,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	#4,-(sp)
	pea.l	HEADER_OFFSET(a4)		*
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	move.w	#2,-(sp)			*I[
	move.l	#0,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError


	lea.l	XVDInput1(pc),a5

	moveq.l	#0,d0
	move.w	WriteFrameNumber(a5),d0
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	move.l	pImageSizeTable(a5),-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	lea.l	XVDInput2(pc),a5

	moveq.l	#0,d0
	move.w	WriteFrameNumber(a5),d0
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	move.l	pImageSizeTable(a5),-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError


	lea.l	XVDInput1(pc),a5

	moveq.l	#0,d0
	move.w	WriteFrameNumber(a5),d0
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	move.l	pPcmSizeTable(a5),-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	lea.l	XVDInput2(pc),a5

	moveq.l	#0,d0
	move.w	WriteFrameNumber(a5),d0
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	move.l	pPcmSizeTable(a5),-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError


	lea.l	ImageDependDataSize(a6),a0
	lea.l	pImageDependData(a6),a1
	moveq.l	#3-1,d7

BackHeaderWriteLoop::

	move.l	(a0),d0

	move.l	#4,-(sp)
	move.l	a0,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	addq.l	#4,a1
	tst.l	(a0)+
	beq	@F

	subq.l	#4,a0				*߂
	subq.l	#4,a1

	move.l	(a0)+,-(sp)
	move.l	(a1)+,-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError
@@:
	dbra	d7,BackHeaderWriteLoop

******************************************************************
**				END				**
******************************************************************

END::
	DOS	_ALLCLOSE

	DOS	_EXIT

******************************************************************
**			Sub Routine				**
******************************************************************
******************************************
**		Data Write		**
******************************************

DataWrite::
	move.w	WriteFrameNumber(a5),d1
	move.l	pImageSizeTable(a5),a0
	subq.w	#1,d1
	moveq.l	#0,d2

	move.l	MaxMermorySize(a6),d3
	sub.l	ImageSize(a6),d3
	sub.l	PCM_BLOCK_SIZE(a5),d3

CulcLoop1::
		add.l	(a0)+,d2
		add.l	PCM_BLOCK_SIZE(a5),d2
		cmp.l	d3,d2
		bhi	DataRead1
CulcLoop2::
		dbra	d1,CulcLoop1

DataRead1::
	move.l	d2,-(sp)
	move.l	pWriteData(a6),-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.l	d2,-(sp)
	move.l	pWriteData(a6),-(sp)
	move.w	FileHundle(a4),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	moveq.l	#0,d2
	cmpi.w	#-1,d1
	bne	CulcLoop2

	rts

******************************************
**		Header Read		**
******************************************

HeaderRead::
	move.w	#2,-(sp)			* READ
	pea.l	FileName(a5)
	DOS	_OPEN				*
	addq.l	#6,sp

		bmi	OpenError
		move.w	d0,FileHundle(a5)

	move.l	#192,-(sp)			*Poster_Data܂ł̃wb_ől
	pea.l	MAGIC_HEADER(a5)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	HEADER_OFFSET(a5),-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	FRAME_NUMBER(a5),d0
	add.l	d0,d0
	add.l	d0,d0				*x4
	move.l	d0,d1
	add.l	d0,d0				*x8

	move.l	d0,-(sp)
	DOS	_MALLOC
	addq.l	#4,sp

		tst.l	d0
		bmi	MallocError

	move.l	d0,pImageSizeTable(a5)
	add.l	d1,d0
	move.l	d0,pPcmSizeTable(a5)

	move.l	FRAME_NUMBER(a5),d0
	lsl.l	#3,d0

	move.l	d0,-(sp)
	move.l	pImageSizeTable(a5),-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	lea.l	XVDInput1(pc),a0
	tst.w	priorityFlag(a6)
	beq	@F
	lea.l	XVDInput2(pc),a0
@@:
	cmpa.l	a0,a5
	bne	HeaderReadEnd


	lea.l	ImageDependDataSize(a6),a0
	lea.l	pImageDependData(a6),a1
	moveq.l	#3-1,d7

BackHeadeReadLoop::
	move.l	#4,-(sp)
	move.l	a0,-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.l	(a0),d0

	move.l	(a0),-(sp)
	DOS	_MALLOC
	addq.l	#4,sp

		tst.l	d0
		bmi	MallocError

	move.l	d0,(a1)

	move.l	(a0)+,-(sp)
	move.l	(a1)+,-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	dbra	d7,BackHeadeReadLoop

HeaderReadEnd::
	rts

******************************************
**		Data Check		**
******************************************

DataCheck::
	cmpi.l	#'XVDF',MAGIC_HEADER(a5)
	bne	NotXvdData

	cmpi.w	#$0002,FORMAT_REVISION(a5)
	bne	NotRev2

	move.w	IMAGE_TYPE+2(a5),d0
	beq	@F
	cmpi.w	#3,d0
	bcs	ImageTypeError
@@:
	move.w	FRAME_NUMBER+2(a5),d0
	subq.w	#1,d0
	move.w	inputEndNumber(a5),d1
	bne	@F
	move.w	d0,inputEndNumber(a5)		* Last Frame
	move.w	d0,d1
@@:
	cmp.w	d0,d1
	bhi	OverEndNumberError

	cmp.w	inputStartNumber(a5),d1
	bcs	OverEndNumberError

	rts

******************************************
**		Start Seek		**
******************************************

StartSeek::
	move.l	pImageSizeTable(a5),a0
	move.l	pPcmSizeTable(a5),a1
	move.l	DATA_OFFSET(a5),d0
	move.w	inputStartNumber(a5),d1
	beq	1F
	subq.w	#1,d1
@@:
		add.l	(a0)+,d0		
		addq.l	#4,a1			*悤ɃJEg
		add.l	PCM_BLOCK_SIZE(a5),d0
		dbra	d1,@B
1:
	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d0,-(sp)
	move.w	FileHundle(a5),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	a0,pImageSizeTable(a5)
	move.l	a1,pPcmSizeTable(a5)
	rts

******************************************
**		Get Strings		**
******************************************

GetStrings::
	move.b	(a2)+,d0
	cmpi.b	#SPACE,d0
	beq	GetStrings
	move.b	d0,(a1)+
@@:
	move.b	(a2)+,d0
	beq	@f
	cmpi.b	#SPACE,d0
	beq	@f
	move.b	d0,(a1)+
	bra	@b
@@:
	clr.b	(a1)+
	rts

*****************************
* IvV̔&򏈗 *
*****************************

SetOption::
	movem.l	d7/a3-a4,-(sp)
	clr.l	d7
	lea.l	OPTIONS(pc),a4
NextCheck::
	movea.l	a2,a3
CheckContinue::
	cmpm.b	(a4)+,(a3)+
	bne	NextMatch
	cmpi.b	#$00,(a4)
	beq	JumpOption
	bra	CheckContinue
NextMatch::
	addq.l	#1,d7
SkipOption::
	tst.b	(a4)+
	bne	SkipOption
	tst.b	(a4)
	beq	IreagalOption
	bra	NextCheck
JumpOption::
	lea.l	OPTION_TABLE(pc),a5
	lsl.l	#2,d7
	movea.l	$00(a5,d7.l),a5
	jsr	(a5)
	movea.l	a3,a2
	movem.l	(sp)+,d7/a3-a4
	moveq.l	#$00,d0
	rts
IreagalOption::
	movem.l	(sp)+,d7/a3-a4
	moveq.l	#$ff,d0
	rts


Asc2int::
	movem.l	d1-d2,-(sp)
	moveq.l	#0,d0
	moveq.l	#0,d1
GetAsc2int::
	tst.b	(a3)
	beq	Asc2intEnd
	cmpi.b	#SPACE,(a3)
	beq	Asc2intEnd
	cmpi.b	#',',(a3)
	beq	BeforeAsc2intEnd
	move.l	d0,d2
	add.l	d0,d0
	lsl.l	#3,d2
	add.l	d2,d0
	move.b	(a3)+,d1
	subi.b	#$30,d1
	add.l	d1,d0
	bra	GetAsc2int
BeforeAsc2intEnd::
	tst.b	(a3)
	beq	Asc2intEnd
	addq.l	#1,a3			*ی

Asc2intEnd::
	movem.l	(sp)+,d1-d2
	rts

**********************
* Option Sub Routine *
**********************

SetPriority::
	move.w	#1,priorityFlag(a6)
	rts

SetInput1FrameNumber::
	lea.l	XVDInput1(pc),a5
	bra	InputNumber
SetInput2FrameNumber::
	lea.l	XVDInput2(pc),a5
InputNumber:
	lea.l	inputStartNumber(a5),a0
	lea.l	inputEndNumber(a5),a1
@@:
	cmpi.b	#SPACE,(a2)
	bne	@F
	rts
@@:
	bsr	Asc2int
	move.w	d0,(a0)
	bsr	Asc2int
	move.w	d0,(a1)
	rts

******************************************************************
**			Error Routine				**
******************************************************************

NotXvdData::
	pea.l	NotXvdDataMes(pc)
	bra	ErrorPrint
NotRev2::
	pea.l	NotRev2Mes(pc)
	bra	ErrorPrint
ImageTypeError::
	pea.l	ImageTypeErrorMes(pc)
	bra	ErrorPrint
OverEndNumberError::
	pea.l	OverEndNumberErrorMes(pc)
	bra	ErrorPrint
OverFlowError::
	pea.l	OverFlowErrorMes(pc)
	bra	ErrorPrint
NotMatchHeader::
	pea.l	NotMatchHeaderMes(pc)
	bra	ErrorPrint

OpenError::
	pea.l	OpenErrorMes(pc)
	bra	ErrorPrint
ReadError::
	pea.l	ReadErrorMes(pc)
	bra	ErrorPrint
SeekError::
	pea.l	SeekErrorMes(pc)
	bra	ErrorPrint
WriteError::
	pea.l	WriteErrorMes(pc)
	bra	ErrorPrint
NewfileError::
	pea.l	NewfileErrorMes(pc)
	bra	ErrorPrint
MallocError::
	pea.l	MallocErrorMes(pc)

ErrorPrint::
	DOS	_PRINT
	DOS	_EXIT

******************************************************************
**				data aria			**
******************************************************************

		.data
		.quad

OPTION_TABLE::
	.dc.l	SetPriority
	.dc.l	SetInput1FrameNumber
	.dc.l	SetInput2FrameNumber

OPTIONS::
	.dc.b	'p',0
	.dc.b	'a',0
	.dc.b	'b',0,0

	.even

*************************
*	Message		*
*************************

TitleMes::
	.dc.b	'xvdcat ver'
	.dc.b	Version
	.dc.b	SPACE
	.dc.b	Date
	.dc.b	SPACE
	.dc.b	Author
	.dc.b	CR,LF,CR,LF,0
USAGE::
	.dc.b	"usage : xvdcat <option> input1 input2 output",CR,LF
	.dc.b	CR,LF
	.dc.b	"option: -a[num],[num] : input1's Start and End frame number (0n65535)",CR,LF
	.dc.b	"      : -b[num],[num] : input2's Start and End frame number (0n65535)",CR,LF
	.dc.b	"      : -p            : use input2's Header",CR,LF,0 

NoFileMes::		.dc.b	'wt@C݂͑܂D',CR,LF,0
NoOptionMes::		.dc.b	'w肳ꂽIvV݂͑܂D',CR,LF,0
NotXvdDataMes::		.dc.b	'XVDt@Cł͂܂D',CR,LF,0
ImageTypeErrorMes::	.dc.b	' Image Type ɂ͑ΉĂ܂D',CR,LF,0
NotRev2Mes::		.dc.b	'Revision 2 ł͂܂D',CR,LF,0
OverEndNumberErrorMes::	.dc.b	'StartNumberEndNumberI',CR,LF,0
OverFlowErrorMes::	.dc.b	'쐬t@C̃t[ 65536 zĂ܂D',CR,LF,0
NotMatchHeaderMes::	.dc.b	'Af[^̍\Ⴂ܂D',CR,LF,0

OpenErrorMes::		.dc.b	'w肳ꂽt@CJ܂D',CR,LF,0
ReadErrorMes::		.dc.b	'w肳ꂽt@Cǂ߂܂D',CR,LF,0
WriteErrorMes::		.dc.b	't@Cɏ߂܂D',CR,LF,0
SeekErrorMes::		.dc.b	'w肳ꂽt@CV[Nł܂D',CR,LF,0
MallocErrorMes::	.dc.b	'mۂł܂D',CR,LF,0
NewfileErrorMes::	.dc.b	'̃t@C쐬ł܂D',CR,LF,0

******************************************************************
**				bss aria			**
******************************************************************

	.bss
	.even

XVDInput1::
	.ds.b	XVD_WORK_SIZE
XVDInput2::
	.ds.b	XVD_WORK_SIZE
XVDOutput::
	.ds.b	XVD_WORK_SIZE
WORK::
	.ds.b	WORK_SIZE
WORKend::

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
