/*
 * isd_header.h - .isd header definition
 *   Copyright (C)1999 Tachibana Eriko
 */

#ifndef isd_header_h
#define isd_header_h

#include <cdecl.h>

#define ISPR_ID "ISPR-V"

typedef struct {
  unsigned char id[6];
  unsigned char version[4];
  unsigned int_ x_length;
  unsigned int_ y_length;
  unsigned int_ interval;
  unsigned int_ interval2;
  unsigned int_ pcm_mode;
  unsigned int_ frame_size;
  unsigned int_ header_size;
  unsigned char cm_id[2];
  unsigned char comment[984];
} IsdHeader;

typedef struct {
  unsigned char* gvram;
  unsigned short x_length;
  unsigned short y_length;
  unsigned int_ x_offset;
  unsigned int_ y_offset;
  unsigned short g_data[0];
} IsdFrameHeader;

#endif /* !isd_header_h */
