/*
 * sdr - 'SCSI Direct Read' header file
 *   Copyright (C)1999 Tachibana Eriko
 */

#ifndef sdr_h
#define sdr_h

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

/* Structures */
typedef struct {
  int_ id;				/* SCSI ID */
  int_ size;				/* ubNTCY(0`3) */
  int_ buf_rest;			/* obt@coCg */
  int_ blk_no;				/* ̃`FC̃ubNʒu */
  int_ blk_rest;			/* ̃`FC̎cubN */
  int_* next;				/* ̃`FC̃AhX */
  int_ reserved1[2];
  unsigned char buf[2048];		/* [ǂݍ݃obt@ */
  int_ list[0];				/* FATCHK obt@ */
} SDR;

/* External functions */
extern SDR* SDRopen (__const char* filename);
extern int_ SDRclose (SDR* sdr);
extern int_ SDRread (SDR* sdr, void* ptr, int_ size);

#endif /* !sdr_h */
