* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _int.s,v 1.0 1995/02/13 20:50:52 nenetto Exp $
*
		.xdef	_int_set
		.xdef	_int_reset
		.xdef	_int_init
		.xdef	V_int

DI		macro
		ori.w	#$0700,sr
		endm

EI		macro
		andi.w	#$f8ff,sr
		endm


* ------------------------------------------------------------
		.data
T_int::		.dcb.l	2*128,0
			* object data id(.l), int routine(.l)
		.text

* ------------------------------------------------------------
*	荞ݓo^
*
*	input	d0.l : object data id
*		d1.l : int routine address
*		d7.l : ----
*	output	d7.l : ----
*
_int_set:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		add.l	#$8000_0000,d0
		lea	T_int,a6
		moveq	#128-1,d6
		1:	tst.l	(a6)
			beq	2f
			cmp.l	(a6),d0
			beq	2f
			addq	#8,a6
		dbra	d6,1b
		bra	3f
		
	2:	move.l	d0,(a6)
		move.l	d1,4(a6)
	3:	
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts


* ------------------------------------------------------------
*	荞ݍ폜
*
*	input	d0.l : object data id
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_int_reset:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		add.l	#$8000_0000,d0
		lea	T_int,a6
		moveq	#128-1,d6
		1:	cmp.l	(a6),d0
			bne	2f
			clr.l	(a6)
			clr.l	4(a6)
		2:	addq	#8,a6
		dbra	d6,1b
		
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts


* ------------------------------------------------------------
*	荞ݏ
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_int_init:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	T_int,a6
		moveq	#128-1,d6
		1:	clr.l	(a6)+
			clr.l	(a6)+
		dbra	d6,1b
		
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts


* ------------------------------------------------------------
*	荞ݓ[`
*
*	SETF Őݒ
*
V_int:
		DI
		movem.l	d0-d7/a0-a6,-(sp)
		
		lea	T_int,a6
		moveq	#128-1,d6
		1:	tst.l	(a6)
			beq	2f
			movea.l	4(a6),a0
			 jsr	(a0)
			cmp.l	#0,d7
			bne	2f
			clr.l	(a6)
			clr.l	4(a6)
		2:	addq	#8,a6
		dbra	d6,1b
		
		movem.l	(sp)+,d0-d7/a0-a6
		EI
		rts
* ------------------------------------------------------------


		.end
