* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _pcm.s,v 1.0 1995/02/13 20:50:52 nenetto Exp $
*
		.xdef	_pcm_play
		.xdef	_pcm_loop_play
		.xdef	_pcm_loop_stop


* ------------------------------------------------------------
*	AC`FC PCMĐ
*
*	input	d0.l : data address
*		d1.l : data length
*		d7.w : pcm rate*$100 +pan
*	output	d7.l : ----
*
_pcm_play:
		movem.l	d0-d7/a0-a6,-(sp)
	
		moveq	#0,d2
		lea	B_chain_table,a1
		1:	addq	#1,d2
			move.l	d0,(a1)+
			add.l	#$ffff,d0
			move.w	#$ffff,(a1)+
			sub.l	#$ffff,d1
			bgt	1b
			add.l	#$ffff,d1
			move.w	d1,-(a1)
	
		moveq	#$67,d0
		moveq	#0,d1
		trap	#15			* IOCS _ADPCMMOD
	
		moveq	#$62,d0
		move.w	d7,d1
		lea	B_chain_table,a1
		trap	#15			* IOCS _ADPCMAOT
	
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	NAC`FC PCMĐ
*
*	input	d0.l : data address
*		d1.l : data length
*		d7.w : pcm rate*$100 +pan
*	output	d7.l : ----
*
_pcm_loop_play:
		movem.l	d0-d7/a0-a6,-(sp)
	
		lea	B_chain_table,a1
		1:	move.l	d0,(a1)+
			add.l	#$ffff,d0
			move.w	#$ffff,(a1)+
			move.l	a1,(a1)
			add.l	#4,(a1)+
			sub.l	#$ffff,d1
			bgt	1b
			add.l	#$ffff,d1
			move.w	d1,-6(a1)
			move.l	#B_chain_table,-(a1)
	
		moveq	#$67,d0
		moveq	#0,d1
		trap	#15			* IOCS _ADPCMMOD
	
		moveq	#$64,d0
		move.w	d7,d1
		lea	B_chain_table,a1
		trap	#15			* IOCS _ADPCMLOT
	
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ------------------------------------------------------------
*	NAC`FC PCM~
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.w : ----
*	output	d7.l : ----
*
_pcm_loop_stop:
		move.l	a0,-(sp)
	
		lea	B_chain_table,a0
		move.l	#D_pcm_end,(a0)+
		move.w	#1,(a0)+
		clr.l	(a0)
	
		move.l	(sp)+,a0
		rts

D_pcm_end:	.dc.b	$80,$80
* ------------------------------------------------------------


		.bss
B_chain_table::	.ds.w	64*5
		.text
* ------------------------------------------------------------


		.end
