******************************************************************
**								**
**		.xvd easy Frame Viewer 2	ver0.76		**
**								**
**						by ӂȂۂ	**
**								**
**					since May 20 1997	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	CONST.H

	.cpu	68000


	.offset	0

SSP_SAVE::		.ds.l	1

MAGIC_HEADER::		.ds.b	4
DATA_AUTHOR::		.ds.b	32
SUB_TITLE::		.ds.b	32
TITLE::			.ds.b	64
END_MARKER::		.ds.b	4
FORMAT_REVISION::	.ds.b	4
DATA_OFFSET::		.ds.b	4
HEADER_OFFSET::		.ds.b	4
FRAME_NUMBER::		.ds.b	4
X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ASPECT_RATIO::		.ds.b	4
IMAGE_TYPE::		.ds.b	4
BASE_TIME_UNIT::	.ds.b	4
FRAME_RATE::		.ds.b	4
PCM_TYPE::		.ds.b	4
PCM_CHANNEL::		.ds.b	4
PCM_FREQENCY::		.ds.b	4
PCM_BLOCK_SIZE::	.ds.b	4

ON_GET_NUMBER::		.ds.w	1			*-f temp
ON_X_NUMBER::		.ds.w	1			*-a X
ON_Y_NUMBER::		.ds.w	1			*-a  ,Y
ONE_FRAME_ONLY_FLAG::	.ds.w	1			*-a only
POSTER_FLAG::		.ds.w	1			*-f nothing
GET_START_FRAME_NUMBER::.ds.w	1			*-sn
GET_END_FRAME_NUMBER::	.ds.w	1			*-en

IMAGE_SIZE::		.ds.l	1			*1 frame size
MINUS_ONE_BLOCK_SIZE::	.ds.l	1
PLUS_TEN_BLOCK_SIZE::	.ds.l	1
MINUS_TEN_BLOCK_SIZE::	.ds.l	1
PLUS_HUNDLED_BLOCK_SIZE::	.ds.l	1
MINUS_HUNDLED_BLOCK_SIZE::	.ds.l	1
PLUS_THOUSAND_BLOCK_SIZE::	.ds.l	1
MINUS_THOUSAND_BLOCK_SIZE::	.ds.l	1
LAST_BLOCK_SIZE::	.ds.l	1
Y_HIGHT::		.ds.w	1
ON_IMAGE_NUMBER::	.ds.w	1
X_ON_POINT::		.ds.l	1			*address
Y_ON_POINT::		.ds.l	1			*address
X_LOOP::		.ds.w	1			*How much X
Y_LOOP::		.ds.w	1			*         Y
MEMPTR::		.ds.l	1			*_malloc
CULC_X_LENGTH::		.ds.w	1			*+GV-RAM address
CULC_Y_LENGTH::		.ds.w	1			*+GV-RAM address
CULLENT_NUMBER::	.ds.w	1
CRTMODE_FLAG::		.ds.w	1
NUMBER_TEMP::		.ds.b	6
FILE_NAME::		.ds.b	256
STRBUF::		.ds.b	10
TEXT_PALET_BUF::	.ds.w	16
CRTMOD_BUF::		.ds.w	1

WORK_SIZE::

	.text
	.even

	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,a1

	lea.l	$c4(a0),a5			*filename

	lea.l	(16,a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

	lea.l	WORK(pc),a6

	lea.l	ON_GET_NUMBER(a6),a0
	moveq.l	#0,d0
	moveq.l	#7-1,d7
@@:
	move.w	d0,(a0)+			*ON_GET_NUMBER`
	dbra	d7,@B				*GET_END_FRAME_NUMBER

	addq.l	#5,a5
	cmpi.b	#'3',(a5)
	bne	@F

	ori.w	#%0000_0100,POSTER_FLAG(a6)
@@:

**********************************************************
**		Comand Line Option Check		**
**********************************************************
C_CHECK::
	addq.l	#1,a2
	bsr	SKIPSP				*Xy[XXLbv
	tst.b	(a2)				*邩H
	beq	USAGE				*Ȃ USAGE

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK
	bra	GETARG				*t@C

OP_CHECK::
	addq.l	#1,a2				*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0			*ꕶo
	cmpi.b	#"3",d0
	beq	SVDFV3_MODE_ON
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#"F",d0
	beq	ON_FRAME_NUMBER_GET
	cmpi.b	#"A",d0
	beq	ABSOLUTE_NUMBER_GET
	cmpi.b	#"V",d0
	beq	VIEW_MODE_ON
	cmpi.b	#"S",d0
	beq	START_FRAME_NUMBER_GET
	cmpi.b	#"E",d0
	beq	END_FRAME_NUMBER_GET
	bra	C_CHECK

SVDFV3_MODE_ON::
	ori.w	#%0000_0100,POSTER_FLAG(a6)
	bra	C_CHECK

VIEW_MODE_ON::
	ori.w	#%0000_0010,POSTER_FLAG(a6)
	bra	C_CHECK

ON_FRAME_NUMBER_GET::
	ori.w	#%0000_0001,POSTER_FLAG(a6)
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_NUMBER0_1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GET_NUMBER0_1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_NUMBER0

GET_NUMBER0_1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#$0000_FFFF,d2
	bgt	OVER_FLOW_FRAME
	move.w	d2,ON_GET_NUMBER(a6)
	bra	C_CHECK

ABSOLUTE_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_X_NUMBER0::
	cmpi.b	#',',(a2)
	beq	GET_X_NUMBER1
	cmpi.b	#SPACE,(a2)
	beq	ONE_FRAME_ONLY			* -a ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_X_NUMBER0

GET_X_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.w	#511,d2
	bgt	OVER_X_NUMBER
	move.w	d2,ON_X_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	addq.l	#1,a2

GET_Y_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_Y_NUMBER1
	cmpi.b	#TAB,(a2)
	beq	GET_Y_NUMBER1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_Y_NUMBER0

GET_Y_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.w	#511,d2
	bgt	OVER_Y_NUMBER
	move.w	d2,ON_Y_NUMBER(a6)
	bra	C_CHECK

ONE_FRAME_ONLY::
	tst.l	d7
	bne	IN_NUMBER_ERR
	move.w	#1,ONE_FRAME_ONLY_FLAG(a6)
	subq.l	#1,a2
	bra	C_CHECK

START_FRAME_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_START_FRAME_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_START_FRAME_NUMBER1		*-s ̎
	cmpi.b	#TAB,(a2)
	beq	GET_START_FRAME_NUMBER1		*-s ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_START_FRAME_NUMBER0

GET_START_FRAME_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#$0000_FFFF,d2
	bgt	OVER_FLOW_FRAME
	move.w	d2,GET_START_FRAME_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	bra	C_CHECK

END_FRAME_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_END_FRAME_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_END_FRAME_NUMBER1		*-e ̎
	cmpi.b	#TAB,(a2)
	beq	GET_END_FRAME_NUMBER1		*-e ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_END_FRAME_NUMBER0

GET_END_FRAME_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#$0000_FFFF,d2
	bgt	OVER_FLOW_FRAME
	move.w	d2,GET_END_FRAME_NUMBER(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	bra	C_CHECK

GETARG::
	lea.l	FILE_NAME(a6),a0

GETARG0::
	tst.b	(a2)				*̏I[R[hH
	beq	GETARG1

	cmpi.b	#SPACE,(a2)
	beq	GETARG1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GETARG1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ

	bra	GETARG0

GETARG1::
	clr.b	(a0)				*I[R[h

**********************************************************
**		READ .xvdFILE's HEAD 			**
**********************************************************
READ_FILE::
	move.w	#2,-(sp)			*READ only
	pea.l	FILE_NAME(a6)			*t@C
	DOS	_OPEN				*open
	addq.l	#6,sp

		move.w	d0,a5				*t@Cnha5֕ۑ
		bmi	OPEN_ERROR

	move.l	#192,-(sp)			*Poster_Data܂ł̃wb_ől
	pea.l	MAGIC_HEADER(a6)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR
**********************************************************
**			XVD Check			**
**********************************************************
	cmpi.l	#'XVDF',MAGIC_HEADER(a6)
	bne	NOT_XVDDATA

	move.l	FRAME_NUMBER(a6),d0
	subq.l	#1,d0
	moveq.l	#0,d1
	move.w	ON_GET_NUMBER(a6),d1
	cmp.l	d1,d0
	blt	NUMBER_OVER

	cmpi.w	#$0002,FORMAT_REVISION(a6)
	bne	NOT_REV200

	tst.l	IMAGE_TYPE(a6)
	bne	NOT_IMAGE_TYPE0

	move.w	ON_X_NUMBER(a6),d0
	move.w	X_LENGTH+2(a6),d1
	add.w	d0,d1
	cmpi.w	#512,d1
	bgt	OVER_X_NUMBER

	move.w	ON_Y_NUMBER(a6),d0
	move.w	Y_LENGTH+2(a6),d1
	add.w	d0,d1
	cmpi.w	#512,d1
	bgt	OVER_Y_NUMBER

	move.w	X_LENGTH+2(a6),d0
	move.w	d0,d2
	move.w	Y_LENGTH+2(a6),d1

	mulu.w	d1,d0
	add.l	d0,d0				*d1:Image_Size

	move.l	d0,IMAGE_SIZE(a6)

	subq.w	#1,d1

	move.w	d2,d3
	lsr.w	#1,d2				*d2/16
	subq.w	#1,d2

	move.w	d2,CULC_X_LENGTH(a6)

	move.w	#512,d4
	sub.w	d3,d4
	add.w	d4,d4
	move.w	d4,CULC_Y_LENGTH(a6)

	move.w	POSTER_FLAG(a6),d0

	cmpi.w	#$4,POSTER_FLAG(a6)
	bcc	SVDFV3_MODE

	tst.w	POSTER_FLAG(a6)			*|X^[p
	beq	POSTER_ON			*|X^[{

**********************************************************
**			To GV-RAM			**
**********************************************************
ONLY_FRAME_CHECK::
	tst.w	ON_Y_NUMBER(a6)
	bne	FRAME_x1
	tst.w	ON_X_NUMBER(a6)
	bne	FRAME_x1			*Wŵ鎞

	tst.w	ONE_FRAME_ONLY_FLAG(a6)
	bne	FRAME_x1			* 1 frame Only
	bra	HOW_MANY_IMAGE

FRAME_x1::
	moveq.l	#1,d7				*\
	move.w	#1,ONE_FRAME_ONLY_FLAG(a6)
	bra	ON_FRAME_CHECK


HOW_MANY_IMAGE::				*\`FbN
	move.w	X_LENGTH+2(a6),d0
	move.w	d0,d1
	moveq.l	#0,d7
@@:
		add.w	d1,d0
		addq.w	#1,d7
		cmpi.w	#512,d0
		ble	@b

	move.w	d7,X_LOOP(a6)			*w։\ł邩

	move.w	Y_LENGTH+2(a6),d0
	move.w	d0,d1
	moveq.l	#0,d6
@@:
		add.w	d1,d0
		addq.w	#1,d6
		cmpi.w	#512,d0
		ble	@b

	move.w	d6,Y_LOOP(a6)			*x։\ł邩

	mulu.w	d6,d7
						*d7ɕ\\t[

	cmpi.w	#$0002,POSTER_FLAG(a6)
	bcc	VIEW_MODE

ON_FRAME_CHECK::
	move.l	FRAME_NUMBER(a6),d0		*d0:t[
	move.l	d0,d5				*Ƃ̃`FbNp
	moveq.l	#0,d6
	move.w	ON_GET_NUMBER(a6),d6		*d6:\Jnt[

	sub.w	d6,d0				*d0:c\t[
	cmp.w	d0,d7				*d7:\\t[
	ble	FL_CHK

	move.w	d0,d7				*d7:ŏI\
FL_CHK::
	move.w	d7,ON_IMAGE_NUMBER(a6)		*ŏI\
	move.l	IMAGE_SIZE(a6),d2
	move.l	PCM_BLOCK_SIZE(a6),d3
	moveq.l	#0,d1

@@:
	add.l	d2,d1				*d0:ړI̊G̃TCY
	dbra	d7,@B
						*d1:IMAGE

	move.l	d1,-(sp)			*image
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,MEMPTR(a6)
		bmi	MALLOC_ERROR

	moveq.l	#0,d1

	tst.w	d6
	beq	1F

	subq.w	#1,d6
	move.l	d3,d0
	add.l	d2,d0
@@:
	add.l	d0,d1
	dbra	d6,@B
						*d1:΂
1:
	add.l	DATA_OFFSET(a6),d1		*0frame ܂ł offset

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d1,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	MEMPTR(a6),a2

	move.l	d2,-(sp)			*TCY
	move.l	a2,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	ON_IMAGE_NUMBER(a6),d7

	subq.l	#1,d7				*Pǂ񂾂
	tst.w	d7				*P̏ꍇ
	beq	COMPLETE

	subq.l	#1,d7				*dbrap

READ_LOOP::
	add.l	d2,a2

	move.w	#1,-(sp)			*݈ʒüړ
	move.l	d3,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d2,-(sp)			*TCY
	move.l	a2,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	dbra	d7,READ_LOOP

COMPLETE::
	move.w	a5,-(sp)
	DOS	_CLOSE				*$FF3E
	addq.l	#2,sp

		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE(a6)		* sspҔ
		addq.l	#4,sp

	tst.l	ASPECT_RATIO(a6)
	beq	SQUARE

X68K_ORIGINAL::
	move.w	#$000C,d1
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	bra	@F

SQUARE::
	move.w	#$000C,d1			*ʃ[hw (C)MZL
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	move.w	#$0110,d1
	IOCS	_CRTMOD
	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

@@:
	move.l	MEMPTR(a6),a0

	lea.l	$00c0_0000,a1
	move.l	a1,X_ON_POINT(a6)
	move.l	a1,Y_ON_POINT(a6)

	tst.w	ONE_FRAME_ONLY_FLAG(a6)
	bne	CULCULATION

	moveq.l	#0,d0
	move.l	d0,d1				*

	move.w	X_LOOP(a6),d0
	subq.w	#1,d0

	move.w	d0,d2				*d2:Y_loop-1
	move.w	Y_LOOP(a6),d1
	subq.w	#1,d1

	sub.w	#1,ON_IMAGE_NUMBER(a6)
LOOP::
	tst.w	ON_IMAGE_NUMBER(a6)
	blt	TO_GRAM_END

	bsr	TO_GRAM				*d0,d1,d2gps
	sub.w	#1,ON_IMAGE_NUMBER(a6)

	moveq.l	#0,d3
	move.w	X_LENGTH+2(a6),d3
	add.w	d3,d3				*X_length x2
	add.l	d3,X_ON_POINT(a6)

	move.l	X_ON_POINT(a6),a1
	dbra	d0,LOOP

	moveq.l	#0,d3
	move.w	Y_LENGTH+2(a6),d3
	lsl.l	#8,d3
	lsl.l	#2,d3				*x1024
	add.l	d3,Y_ON_POINT(a6)
	move.l	Y_ON_POINT(a6),a1
	move.l	a1,X_ON_POINT(a6)
	move.l	d2,d0
	dbra	d1,LOOP

	bra	TO_GRAM_END

CULCULATION::
	moveq.l	#0,d0
	move.l	d0,a1
	move.w	ON_Y_NUMBER(a6),d0
	lsl.l	#8,d0
	lsl.l	#2,d0
	move.w	ON_X_NUMBER(a6),a1
	add.l	a1,d0
	add.l	a1,d0
	add.l	#$00c0_0000,d0
	move.l	d0,a1

	bsr	TO_GRAM
	bra	TO_GRAM_END

**********************************************************
**			POSTER ON			**
**********************************************************
POSTER_ON::
	move.w	#2,ONE_FRAME_ONLY_FLAG(a6)

	move.l	IMAGE_SIZE(a6),d1

	move.l	d1,-(sp)
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,MEMPTR(a6)
		bmi	MALLOC_ERROR

	move.w	#0,-(sp)			*擪̃ItZbg
	move.l	#192,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,-(sp)
	move.l	MEMPTR(a6),-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	bra	COMPLETE

**********************************************************
**			View Mode			**
**********************************************************
VIEW_MODE::
						*d7:\\
	move.w	d7,ON_IMAGE_NUMBER(a6)
	move.l	FRAME_NUMBER(a6),d6

	moveq.l	#0,d1
	move.l	d1,d2
	move.w	GET_START_FRAME_NUMBER(a6),d1
	move.w	GET_END_FRAME_NUMBER(a6),d2
	bne	@F

	move.w	d6,GET_END_FRAME_NUMBER(a6)
	move.w	d6,d2
@@:
	cmp.w	d1,d2
	ble	END_FRAME_OVER_START_FRAME	*-s  -e
	cmp.l	d1,d6
	blt	START_FRAME_OVER		*-s  total frame
	cmp.l	d2,d6
	blt	END_FRAME_OVER			*-e  total frame

	sub.w	d1,d2

	cmp.w	d7,d2				*
	ble	ON_FRAME_CHECK			*ʕ\t[

	divu.w	d7,d2
	andi.l	#$0000_FFFF,d2			*d2.w:΂t[

	move.l	IMAGE_SIZE(a6),d1
	move.l	d1,d3
	subq.w	#1,d7				*dbrap
	move.w	d7,d5
@@:
	add.l	d1,d3
	dbra	d7,@B

	move.l	d3,-(sp)			*image
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,MEMPTR(a6)
		bmi	MALLOC_ERROR

	move.l	d0,a0
	move.l	PCM_BLOCK_SIZE(a6),d3
	add.l	d1,d3
	subq.w	#1,d2				*dbrap
	moveq.l	#0,d4
@@:
	add.l	d3,d4
	dbra	d2,@B

	add.l	PCM_BLOCK_SIZE(a6),d4

	moveq.l	#0,d2
	move.w	GET_START_FRAME_NUMBER(a6),d6
	tst.w	d6
	beq	1F

	subq.w	#1,d6
	move.l	IMAGE_SIZE(a6),d0
	add.l	PCM_BLOCK_SIZE(a6),d0
@@:
	add.l	d0,d2
	dbra	d6,@B
1:
	add.l	DATA_OFFSET(a6),d2

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d2,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,-(sp)			*TCY
	move.l	a0,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	subq.w	#1,d5
@@:
	move.w	#1,-(sp)			*ݒnSEEK
	move.l	d4,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	adda.l	d1,a0

	move.l	d1,-(sp)			*TCY
	move.l	a0,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	dbra	d5,@B

	bra	COMPLETE

**********************************************************
**			SVDFV3 MODE			**
**********************************************************
SVDFV3_MODE::
	clr.w	CULLENT_NUMBER(a6)

	move.w	Y_LENGTH+2(a6),d0
	move.w	d0,d1
	lsr.w	#4,d0				*/16
	move.w	d0,d2
	lsl.w	#4,d2

	cmp.w	d1,d2
	beq	@F
	addq.w	#1,d0
@@:
	move.w	d0,Y_HIGHT(a6)

	move.l	IMAGE_SIZE(a6),d6

	move.l	d6,d0
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,a3
		bmi	MALLOC_ERROR

	move.l	d6,d0
	move.l	PCM_BLOCK_SIZE(a6),d5
	add.l	d5,d0				*d0:ONE BLOCK SIZE
	move.l	d0,d1
	add.l	d1,d1
	move.l	d1,MINUS_ONE_BLOCK_SIZE(a6)

	move.l	d0,d3
	move.l	d3,d4
	lsl.l	#3,d4				*d4=x8
	add.l	d3,d3				*d3=x2
	add.l	d4,d3
	move.l	d3,d4
	sub.l	d0,d3
	move.l	d3,PLUS_TEN_BLOCK_SIZE(a6)
	add.l	d1,d3
	move.l	d3,MINUS_TEN_BLOCK_SIZE(a6)

	move.l	d4,d3
	lsl.l	#3,d3				*d3=x8
	add.l	d4,d4
	add.l	d4,d3
	move.l	d3,d4
	sub.l	d0,d3
	move.l	d3,PLUS_HUNDLED_BLOCK_SIZE(a6)
	add.l	d1,d3
	move.l	d3,MINUS_HUNDLED_BLOCK_SIZE(a6)

	move.l	d4,d3
	lsl.l	#3,d3
	add.l	d4,d4
	add.l	d4,d3
	sub.l	d0,d3
	move.l	d3,PLUS_THOUSAND_BLOCK_SIZE(a6)
	add.l	d1,d3
	move.l	d3,MINUS_THOUSAND_BLOCK_SIZE(a6)

	move.l	FRAME_NUMBER(a6),d2
	subq.l	#2,d2				*dbra,-1
	move.l	DATA_OFFSET(a6),d3		*+1
@@:
	add.l	d0,d3
	dbra	d2,@B

	move.l	d3,LAST_BLOCK_SIZE(a6)

	move.l	DATA_OFFSET(a6),d2
	move.w	ON_GET_NUMBER(a6),d3
	move.w	d3,CULLENT_NUMBER(a6)
	beq	1F
	subq.w	#1,d3
@@:
	add.l	d0,d2				*d0:IMAGE_SIZE
	dbra	d3,@B
1:
	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d2,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d6,-(sp)			*d6:IMAGE_SIZE
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,a4
		bmi	MALLOC_ERROR

	move.l	d6,-(sp)			*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d5,-(sp)			*PCM_BLOCK_SIZE
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR


		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE(a6)		* sspҔ
		addq.l	#4,sp

	IOCS	_OS_CUROF			*$af

	move.w	#-1,d1
	IOCS	_CRTMOD
	move.w	d0,CRTMOD_BUF(a6)

	tst.l	ASPECT_RATIO(a6)
	beq	SQUARE_SVDFV3

X68K_ORIGINAL_SVDFV3::
	move.w	#$000C,d1
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	move.w	#2,CRTMODE_FLAG(a6)

	cmpi.w	#512,X_LENGTH+2(a6)
	bne	@F
	cmpi.w	#240,Y_LENGTH+2(a6)
	bne	@F
	move.w	#4,CRTMODE_FLAG(a6)
	bra	2F

SQUARE_SVDFV3::
	move.w	#$000C,d1			*ʃ[hw (C)MZL
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	move.w	#$0110,d1
	IOCS	_CRTMOD
	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600
	clr.w	CRTMODE_FLAG(a6)
@@:
	cmpi.l	#384,X_LENGTH(a6)
	bhi	2F
1:
	cmpi.w	#256,Y_LENGTH+2(a6)
	bhi	2F

	add.w	#1,CRTMODE_FLAG(a6)
2:
	bsr	CRTMODE_CHANGE

	lea.l	$e82200,a0			*KEEP Text Palet
	lea.l	TEXT_PALET_BUF(a6),a1
	moveq.l	#8-1,d7
@@:
		move.l	(a0)+,(a1)+
		dbra	d7,@B

	lea.l	$e82200,a0			*TEXT Palet
	lea.l	TEXT_PALET(pc),a1
	moveq.l	#8-1,d7
@@:
		move.l	(a1)+,(a0)+
		dbra	d7,@B

	lea.l	TEXT_MASK(pc),a1
	IOCS	_TXFILL

	lea.l	$00c0_0000,a1
	move.l	a4,a0
	bsr	TO_GRAM

	move.w	CULLENT_NUMBER(a6),d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

**************************************************
**		KEY LOOP			**
**************************************************

KEY_LOOP::
	IOCS	_B_KEYSNS
	tst.l	d0
	beq	KEY_LOOP
KEY_LOOP_AF::
	lea.l	$0000_0807,a0

	btst.b	#1,7(a0)			*CTRL
	bne	CTRL_ON
	btst.b	#0,-5(a0)			*TAB
	bne	TAB_ON

	btst.b	#4,(a0)				*
	bne	UP_KEY
	btst.b	#6,(a0)				*
	bne	DOWN_KEY
	btst.b	#3,(a0)				*
	bne	LEFT_KEY
	btst.b	#5,(a0)				*
	bne	RIGHT_KEY
	btst.b	#0,(a0)				*RollUp
	bne	ROLLUP
	btst.b	#1,(a0)				*RollDown
	bne	ROLLDOWN
	btst.b	#5,-1(a0)			*SPACE
	bne	RIGHT_KEY			*Ɠ

	btst.b	#2,-5(a0)			*W
	bne	MEMORY_TO_DISK
	btst.b	#2,-4(a0)			*P
	bne	PLAY_XVD
	btst.b	#4,-2(a0)			*C
	bne	COPY_TO_MEMORY
	btst.b	#2,-2(a0)			*Z
	bne	ZOOM_ON
	btst.b	#6,-2(a0)			*P
	bne	BENCH_MARK
	btst.b	#3,-3(a0)			*H
	bne	HALF_MODE

	btst.b	#1,-7(a0)			*ESC
	bne	SVDFV3_MODE_END

	bra	KEY_LOOP_END


CTRL_ON::					*+10

	btst.b	#0,-5(a0)			*TAB
	bne	CTRL_TAB_ON

	btst.b	#4,(a0)				*
	bne	ROLLUP
	btst.b	#6,(a0)				*
	bne	ROLLDOWN
	btst.b	#3,(a0)				*
	bne	DOWN_KEY
	btst.b	#5,(a0)				*
	bne	UP_KEY
	btst.b	#0,(a0)				*RollUp
	bne	CTRL_ROLLUP
	btst.b	#1,(a0)				*RollDown
	bne	CTRL_ROLLDOWN

	btst.b	#5,-1(a0)			*SPACE
	bne	DOWN_KEY			*Ɠ

	btst.b	#1,-7(a0)			*ESC
	bne	SVDFV3_MODE_END

	bra	KEY_LOOP_END

TAB_ON::					*+100

	btst.b	#1,7(a0)			*CTRL
	bne	CTRL_TAB_ON

	btst.b	#4,(a0)				*
	bne	TAB_UP_KEY
	btst.b	#6,(a0)				*
	bne	TAB_DOWN_KEY
	btst.b	#3,(a0)				*
	bne	ROLLDOWN
	btst.b	#5,(a0)				*
	bne	ROLLUP
	btst.b	#0,(a0)				*RollUp
	bne	CTRL_ROLLUP
	btst.b	#1,(a0)				*RollDown
	bne	CTRL_ROLLDOWN

	btst.b	#5,-1(a0)			*SPACE
	bne	ROLLUP				*Ɠ
	btst.b	#1,-7(a0)			*ESC
	bne	SVDFV3_MODE_END

	bra	KEY_LOOP_END

CTRL_TAB_ON::

	btst.b	#4,(a0)				*
	bne	CTRL_ROLLDOWN
	btst.b	#6,(a0)				*
	bne	CTRL_ROLLUP
	btst.b	#3,(a0)				*
	bne	CTRL_ROLLDOWN
	btst.b	#5,(a0)				*
	bne	CTRL_ROLLUP
	btst.b	#0,(a0)				*RollUp
	bne	CTRL_ROLLUP
	btst.b	#1,(a0)				*RollDown
	bne	CTRL_ROLLDOWN
	btst.b	#5,-1(a0)			*SPACE
	bne	CTRL_ROLLUP			*Ɠ

	btst.b	#1,-7(a0)			*ESC
	bne	SVDFV3_MODE_END

	bra	KEY_LOOP_END

**************************************************
**		KEY ROUTINE			**
**************************************************

LEFT_KEY::					*-1
	move.l	MINUS_ONE_BLOCK_SIZE(a6),d0
	moveq.l	#1,d1
	bra	MINUS

RIGHT_KEY::					*+1
	moveq.l	#1,d1
	bra	PLUS

UP_KEY::					*+10
	move.l	PLUS_TEN_BLOCK_SIZE(a6),d0
	moveq.l	#10,d1
	bra	PLUS

DOWN_KEY::					*-10
	move.l	MINUS_TEN_BLOCK_SIZE(a6),d0
	moveq.l	#10,d1
	bra	MINUS

ROLLDOWN::					*-100
	move.l	MINUS_HUNDLED_BLOCK_SIZE(a6),d0
	moveq.l	#100,d1
	bra	MINUS

ROLLUP::					*+100
	move.l	PLUS_HUNDLED_BLOCK_SIZE(a6),d0
	moveq.l	#100,d1
	bra	PLUS

TAB_UP_KEY::					*+1000
	move.l	PLUS_THOUSAND_BLOCK_SIZE(a6),d0
	move.l	#1000,d1
	bra	PLUS

TAB_DOWN_KEY::					*-1000
	move.l	MINUS_THOUSAND_BLOCK_SIZE(a6),d0
	move.l	#1000,d1
	bra	MINUS

CTRL_ROLLDOWN::
	tst.w	CULLENT_NUMBER(a6)
	beq	@F

	move.w	#0,-(sp)			*擪
	move.l	DATA_OFFSET(a6),-(sp)		*擪܂
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	IMAGE_SIZE(a6),-(sp)		*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)	*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	clr.w	CULLENT_NUMBER(a6)
	moveq.l	#0,d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	$00c0_0000,a1
	move.l	a4,a0
	bsr	TO_GRAM
@@:
	bra	KEY_LOOP_END

CTRL_ROLLUP::
	move.l	FRAME_NUMBER(a6),d1
	moveq.l	#0,d2
	move.w	CULLENT_NUMBER(a6),d2
	subq.l	#1,d1
	move.l	d1,d3
	cmp.l	d1,d2
	beq	@F

	move.w	#0,-(sp)			*擪
	move.l	LAST_BLOCK_SIZE(a6),-(sp)	*Pc܂
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	IMAGE_SIZE(a6),-(sp)		*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)	*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,d0
	move.w	d1,CULLENT_NUMBER(a6)
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	$00c0_0000,a1
	move.l	a4,a0
	bsr	TO_GRAM
@@:
	bra	KEY_LOOP_END

MINUS::
	bsr	MINUS_FRAME_SEEK_READ
	lea.l	$00c0_0000,a1
	move.l	a4,a0
	bsr	TO_GRAM
	bra	KEY_LOOP_END

PLUS::
	bsr	PLUS_FRAME_SEEK_READ
	lea.l	$00c0_0000,a1
	move.l	a4,a0
	bsr	TO_GRAM
*	bra	KEY_LOOP_END

KEY_LOOP_END::
	move.w	#-1,-(sp)
	DOS	_KFLUSH				*L[obt@
	addq.l	#2,sp

	bra	KEY_LOOP

******************************************
**		ZOOM			**
******************************************

ZOOM_ON::
	move.w	CRTMODE_FLAG(a6),d0
	add.w	d0,d0
	move.w	ZOOM_TABLE(pc,d0.w),d0
	jmp	ZOOM_TABLE(pc,d0.w)

ZOOM_TABLE::
	.dc.w	ZOOM_0-ZOOM_TABLE		*768x512
	.dc.w	ZOOM_1-ZOOM_TABLE		*384x256
	.dc.w	ZOOM_2-ZOOM_TABLE		*512x512
	.dc.w	ZOOM_3-ZOOM_TABLE		*256x256
	.dc.w	ZOOM_4-ZOOM_TABLE		*512x256
	.dc.w	ZOOM_5-ZOOM_TABLE		*512x384

ZOOM_0::
	move.w	#1,CRTMODE_FLAG(a6)
	bra	CRTMODE_END

ZOOM_1::
	move.w	#0,CRTMODE_FLAG(a6)
	bra	CRTMODE_END

ZOOM_2::
	move.w	#3,CRTMODE_FLAG(a6)
	bra	CRTMODE_END

ZOOM_3::
	move.w	#2,CRTMODE_FLAG(a6)
	bra	CRTMODE_END

ZOOM_4::
	move.w	#2,CRTMODE_FLAG(a6)
	bra	CRTMODE_END

ZOOM_5::
	move.w	#0,CRTMODE_FLAG(a6)
*	bra	CRTMODE_END

CRTMODE_END::
	bsr	CRTMODE_CHANGE
	bra	KEY_LOOP_END

HALF_MODE::
	move.w	CRTMODE_FLAG(a6),d0
	add.w	d0,d0
	move.w	HALF_TABLE(pc,d0.w),d0
	jmp	HALF_TABLE(pc,d0.w)

HALF_TABLE::
	.dc.w	HALF_5-HALF_TABLE		*768x512
	.dc.w	HALF_5-HALF_TABLE		*384x256
	.dc.w	HALF_4-HALF_TABLE		*512x512
	.dc.w	HALF_4-HALF_TABLE		*256x256
	.dc.w	HALF_2-HALF_TABLE		*512x256
	.dc.w	HALF_0-HALF_TABLE		*512x384

HALF_5::
	move.w	#5,CRTMODE_FLAG(a6)
	bra	HALF_END

HALF_4::
	move.w	#4,CRTMODE_FLAG(a6)
	bra	HALF_END

HALF_2::
	move.w	#2,CRTMODE_FLAG(a6)
	bra	HALF_END

HALF_0::
	move.w	#0,CRTMODE_FLAG(a6)
*	bra	HALF_END

HALF_END::
	bsr	CRTMODE_CHANGE
	bra	KEY_LOOP_END

******************************************
**		Copy to Memory		**
******************************************

COPY_TO_MEMORY::
	move.l	IMAGE_SIZE(a6),d0
	lsr.l	#2,d0				*/4
	subq.l	#1,d0
	move.l	a4,a0
	move.l	a3,a1
@@:
	move.l	(a0)+,(a1)+
	subq.l	#1,d0
	bne	@B

	bra	KEY_LOOP_END

******************************************
**		Write from Memory	**
******************************************

MEMORY_TO_DISK::
	move.l	IMAGE_SIZE(a6),d1
	move.l	PCM_BLOCK_SIZE(a6),d2
	move.l	d1,d3
	add.l	d2,d3
	neg.l	d3

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d3,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d1,-(sp)
	move.l	a3,-(sp)
	move.w	a5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WRITE_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d2,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	lea.l	$00c0_0000,a1
	move.l	a3,a0
	bsr	TO_GRAM

	bra	KEY_LOOP_END

******************************************
**		PLAY			**
******************************************

PLAY_XVD::
	move.l	a3,-(sp)

	move.l	IMAGE_SIZE(a6),d5
	move.l	PCM_BLOCK_SIZE(a6),d6
	move.l	FRAME_NUMBER(a6),d7
	move.w	CULLENT_NUMBER(a6),a3
	sub.l	a3,d7
	subq.l	#2,d7
	bcs	PLAY_XVD_END

PLAY_LOOP:
	addq.l	#1,a3				*CULLENT_NUMBER
	move.l	d5,-(sp)			*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d6,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	lea.l	$00c0_0000,a2
	move.l	a4,a0

	move.w	Y_LENGTH+2(a6),d0
	subq.w	#1,d0
	move.w	CULC_Y_LENGTH(a6),d1
	move.w	CULC_X_LENGTH(a6),d3
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

_LP2::
		move.w	d3,d2
_LP1::
		move.l	(a0)+,(a2)+
		dbra	d2,_LP1

	add.w	d1,a2			* =(512-X)x2
	dbra	d0,_LP2

	move.w	a3,d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	tst.b	$800
	bne	LOOP_OUT

	tst.b	$806
	bne	LOOP_OUT

	dbra	d7,PLAY_LOOP

LOOP_OUT::
	move.w	a3,CULLENT_NUMBER(a6)

PLAY_XVD_END::
	move.l	(sp)+,a3
	bra	KEY_LOOP_END

******************************************
**		BENCH MARK		**
******************************************

BENCH_MARK::
	move.l	FRAME_NUMBER(a6),d7
	sub.w	CULLENT_NUMBER(a6),d7
	cmpi.l	#101,d7
	bcs	BENCH_END

	lea.l	KEISOKU(pc),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$6-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	moveq.l	#100-1,d7

	move.l	a3,-(sp)

	move.w	CULC_Y_LENGTH(a6),a3
	lea.l	$00c0_0000,a2
	move.l	IMAGE_SIZE(a6),d5
	move.l	PCM_BLOCK_SIZE(a6),d6
	move.w	Y_LENGTH+2(a6),d4
	subq.l	#1,d4

	move.l	a6,-(sp)
	move.w	CULC_X_LENGTH(a6),a6

	IOCS	_ONTIME
	move.l	d0,-(sp)

BENCH_LOOP::
	tst.b	$800
	bne	BENCH_LOOP_OUT

	move.l	d5,-(sp)			*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
*	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d6,-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
*	addq.l	#8,sp
	lea.l	10+8(sp),sp			*_READ,_SEEK

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	a2,a1
	move.l	a4,a0

	move.w	d4,d0
	move.w	a3,d1
B_LP2::
		move.w	a6,d3
B_LP1::
		move.l	(a0)+,(a1)+
		dbra	d3,B_LP1

	add.w	d1,a1			* =(512-X)x2
	dbra	d0,B_LP2

	dbra	d7,BENCH_LOOP

BENCH_LOOP_OUT::
	IOCS	_ONTIME
	move.l	(sp)+,d1
	sub.l	d1,d0

	move.l	(sp)+,a6
	move.l	(sp)+,a3

	moveq.l	#99,d6
	sub.l	d7,d6
	andi.l	#$0000_ffff,d6
	add.w	d6,CULLENT_NUMBER(a6)		*C

	move.l	#10000,d1
	moveq.l	#0,d2
	cmp.l	d0,d1
	bcs	CONMA_1
ZERO::
	addq.l	#1,d2				*d2:l
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO

CONMA_1::					*_P
	move.l	d1,d3				*d1:]
	lsl.l	#3,d1
	add.l	d3,d3
	add.l	d3,d1				*d1 x10
	moveq.l	#0,d3

	cmp.l	d0,d1
	bcs	CONMA_2
ZERO_1::
	addq.l	#1,d3				*d3:
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO_1

CONMA_2::					*_Q
	move.l	d1,d4
	lsl.l	#3,d1
	add.l	d4,d4
	add.l	d4,d1				*d1 x10
	moveq.l	#0,d4
	cmp.l	d0,d1
	bcs	CONMA_2
ZERO_2::
	addq.l	#1,d4				*d4:
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO_2

	move.w	d2,d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a0
	addq.l	#5,a0
	move.b	#'.',(a0)+
	add.b	#$30,d3
	move.b	d3,(a0)+
	add.b	#$30,d4
	move.b	d4,(a0)+
	clr.b	(a0)

	lea.l	WHITE(pc),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$6-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$8-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	FPS(pc),a1
	moveq.l	#$3,d1				*
*	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$3-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	move.w	#-1,-(sp)
	DOS	_KFLUSH				*L[obt@
	addq.l	#2,sp
@@:
	IOCS	_B_KEYSNS
	tst.l	d0
	beq	@B

	lea.l	WHITE(pc),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$12-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	move.w	CULLENT_NUMBER(a6),d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	move.w	CULLENT_NUMBER(a6),d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

BENCH_END::
	bra	KEY_LOOP_AF

******************************************
**		END			**
******************************************

SVDFV3_MODE_END::
	lea.l	TEXT_MASK_CLR(pc),a1
	IOCS	_TXFILL

	lea.l	$e82200,a0			*KEEP Text Palet
	lea.l	TEXT_PALET_BUF(a6),a1
	moveq.l	#8-1,d7
@@:
	move.l	(a1)+,(a0)+
	dbra	d7,@B

	IOCS	_OS_CURON			*$ae

	move.w	CRTMOD_BUF(a6),d1
	IOCS	_CRTMOD

	bra	TO_GRAM_END

**********************************************************
**		SVDFV3	SUB ROUTINE			**
**********************************************************
PLUS_FRAME_SEEK_READ::
	moveq.l	#0,d2
	move.w	CULLENT_NUMBER(a6),d2
	move.l	FRAME_NUMBER(a6),d3
	subq.l	#1,d3

	cmp.l	d2,d3
	ble	PLUS_FRAME_SEEK_READ_END

	add.w	d1,d2
	cmp.l	d2,d3
	bhi	@F				*XgzȂꍇ

	move.w	#0,-(sp)			*擪
	move.l	LAST_BLOCK_SIZE(a6),-(sp)	*Pc܂
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.w	d3,CULLENT_NUMBER(a6)
	bra	PLUS_FRAME_READ

@@:
	cmpi.w	#1,d1
	bne	@F

	add.w	d1,CULLENT_NUMBER(a6)
	bra	PLUS_FRAME_READ
@@:
	move.w	#1,-(sp)			*̏ꂩ
	move.l	d0,-(sp)			*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	add.w	d1,CULLENT_NUMBER(a6)

PLUS_FRAME_READ::
	move.l	IMAGE_SIZE(a6),-(sp)		*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)	*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.w	CULLENT_NUMBER(a6),d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

PLUS_FRAME_SEEK_READ_END::

	rts


MINUS_FRAME_SEEK_READ::
	move.w	CULLENT_NUMBER(a6),d2
	beq	MINUS_FRAME_SEEK_READ_END

	sub.w	d1,d2
	bgt	@F				*zȂꍇ

	move.w	#0,-(sp)			*擪
	move.l	DATA_OFFSET(a6),-(sp)		*擪܂
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	clr.w	CULLENT_NUMBER(a6)

	bra	MINUS_FRAME_READ

@@:
	move.w	#1,-(sp)			*̏ꂩ
	neg.l	d0
	move.l	d0,-(sp)			*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	sub.w	d1,CULLENT_NUMBER(a6)

MINUS_FRAME_READ::
	move.l	IMAGE_SIZE(a6),-(sp)		*TCY
	move.l	a4,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)	*
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.w	CULLENT_NUMBER(a6),d0
	bsr	DEC2STR

	lea.l	STRBUF(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Y_HIGHT(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

MINUS_FRAME_SEEK_READ_END::

	rts

CRTMODE_CHANGE::

*	CRTMODE_FLAG(a6)
*	0:768x512		1:384x256	5:512x384
*	2:512x512		3:256x256	4:512x256

	move.w	CRTMODE_FLAG(a6),d0
	add.w	d0,d0
	move.w	CRTMODE_TABLE(pc,d0.w),d0
	jmp	CRTMODE_TABLE(pc,d0.w)

CRTMODE_TABLE::
	.dc.w	TO_768x512-CRTMODE_TABLE
	.dc.w	TO_384x256-CRTMODE_TABLE
	.dc.w	TO_512x512-CRTMODE_TABLE
	.dc.w	TO_256x256-CRTMODE_TABLE
	.dc.w	TO_512x256-CRTMODE_TABLE
	.dc.w	TO_512x384-CRTMODE_TABLE

TO_384x256::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$00e8_0000,a0
	move.w	#$0045,(a0)+		*$E80000	*R0
	move.w	#$0005,(a0)+		*$E80002	*R1
	move.w	#$000a,(a0)+		*$E80004	*R2
	move.w	#$003a,(a0)+		*$E80006	*R3
	move.w	#$0237,(a0)+		*$E80008	*R4
	move.w	#$0005,(a0)+		*$E8000A	*R5
	move.w	#$0028,(a0)+		*$E8000C	*R6
	move.w	#$0228,(a0)+		*$E8000E	*R7
	move.w	#$8311,$E80028				*R20
	bset.b	#1,$E8E007				*HRL

	bra	CRTMODE_CHANGE_END

TO_768x512::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$E80000,a0
	move.w	#$0089,(a0)+		*$E80000	*R0
	move.w	#$000e,(a0)+		*$E80002	*R1
	move.w	#$001c,(a0)+		*$E80004	*R2
	move.w	#$007c,(a0)+		*$E80006	*R3
	move.w	#$0237,(a0)+		*$E80008	*R4
	move.w	#$0005,(a0)+		*$E8000A	*R5
	move.w	#$0028,(a0)+		*$E8000C	*R6
	move.w	#$0228,(a0)+		*$E8000E	*R7
	move.w	#$0316,$E80028				*R20

	bra	CRTMODE_CHANGE_END

TO_512x512::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$E80000,a0
	move.w	#$005b,(a0)+		*$E80000	*R0
	move.w	#$0009,(a0)+		*$E80002	*R1
	move.w	#$0011,(a0)+		*$E80004	*R2
	move.w	#$0051,(a0)+		*$E80006	*R3
	move.w	#$0237,(a0)+		*$E80008	*R4
	move.w	#$0005,(a0)+		*$E8000A	*R5
	move.w	#$0028,(a0)+		*$E8000C	*R6
	move.w	#$0228,(a0)+		*$E8000E	*R7
	move.w	#$0315,$E80028				*R20

	bra	CRTMODE_CHANGE_END

TO_256x256::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$E80000,a0
	move.w	#$002d,(a0)+		*$E80000	*R0
	move.w	#$0004,(a0)+		*$E80002	*R1
	move.w	#$0006,(a0)+		*$E80004	*R2
	move.w	#$0026,(a0)+		*$E80006	*R3
	move.w	#$0237,(a0)+		*$E80008	*R4
	move.w	#$0005,(a0)+		*$E8000A	*R5
	move.w	#$0028,(a0)+		*$E8000C	*R6
	move.w	#$0228,(a0)+		*$E8000E	*R7
	move.w	#$0310,$E80028				*R20

	bra	CRTMODE_CHANGE_END

TO_512x256::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$E80000,a0
	move.w	#$005b,(a0)+		*$E80000	*R0
	move.w	#$0009,(a0)+		*$E80002	*R1
	move.w	#$0011,(a0)+		*$E80004	*R2
	move.w	#$0051,(a0)+		*$E80006	*R3
	move.w	#$0237,(a0)+		*$E80008	*R4
	move.w	#$0005,(a0)+		*$E8000A	*R5
	move.w	#$0028,(a0)+		*$E8000C	*R6
	move.w	#$0228,(a0)+		*$E8000E	*R7
	move.w	#$0311,$E80028				*R20

	bra	CRTMODE_CHANGE_END

TO_512x384::
0:
	btst.b	#4,$E88001
	beq	0b
0:
	btst.b	#4,$E88001
	bne	0b
0:
	btst.b	#4,$E88001
	bne	0b

	lea.l	$E80000,a0
	move.w	#$0089,(a0)+		*$E80000	*R0
	move.w	#$000a,(a0)+		*$E80002	*R1
	move.w	#$002c,(a0)+		*$E80004	*R2
	move.w	#$006c,(a0)+		*$E80006	*R3
	move.w	#$020b,(a0)+		*$E80008	*R4
	move.w	#$0007,(a0)+		*$E8000A	*R5
	move.w	#$0048,(a0)+		*$E8000C	*R6
	move.w	#$01c8,(a0)+		*$E8000E	*R7
	move.w	#$0316,$E80028				*R20

*	bra	CRTMODE_CHANGE_END

CRTMODE_CHANGE_END::
	rts

**********************************************************
**			END				**
**********************************************************
TO_GRAM_END::
		move.l	SSP_SAVE(a6),-(sp)	*
		DOS	_SUPER			* [U[[h
		addq.l	#4,sp			*

	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************
TO_GRAM::
	move.w	Y_LENGTH+2(a6),d6
	subq.w	#1,d6
	move.w	CULC_Y_LENGTH(a6),d4
	move.w	CULC_X_LENGTH(a6),d5
LP2::
		move.w	d5,d7
LP1::
		move.l	(a0)+,(a1)+
		dbra	d7,LP1

		add.w	d4,a1			* =(512-X)x2
		dbra	d6,LP2
	rts

GET_NUMBER1::
	moveq.l	#0,d0
	moveq.l	#0,d2
	move.l	d7,d5
	subq.l	#1,d5

	subq.l	#2,d7		*dbrap-2
	move.l	d7,d6
1:
	move.l	d6,d7
	move.b	(a0)+,d0
		cmpi.b	#'0',d0			*0`9AA`ZȊO͒e
		bcs	IN_NUMBER_ERR		*
		cmpi.b	#'9'+1,d0		*
		bcc	IN_NUMBER_ERR		*
		subi.b	#$30,d0			*𐔎ɂ

		cmpi.l	#-1,d7
		ble	GET_NUMBER3
2:
	move.l	d0,d1			*d0=d1
	add.l	d1,d1			*d1=x2
	lsl.l	#3,d0			*d0=x8
	add.l	d1,d0			*d0=x10
	dbra	d7,2B

GET_NUMBER3::
	add.l	d0,d2
	moveq.l	#0,d0
	subq.l	#1,d6
	dbra	d5,1B
	rts


SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

******************************************
**		Dec to Str		**
******************************************

DEC2STR::					*d0.wDECŕ\
	movem.l	d0-d3/a0-a1,-(sp)
		lea.l	DEC_TABLE(pc),a0
		lea.l	STRBUF(a6),a1

DEC2STR_START::
		move.w	(a0)+,d1
		beq	EXIT
		moveq.l	#$00,d2
@@:
		move.w	d0,d3
		sub.w	d1,d0
		bcs	1f
		addq.l	#1,d2
		bra	@b
1:
		move.w	d3,d0
		addi.b	#'0',d2
		move.b	d2,(a1)+
		bra	DEC2STR_START

EXIT::
		move.b	#$00,(a1)+

* zero suppress
		lea.l	STRBUF(a6),a1
@@:
		move.b	(a1)+,d0
		tst.b	d0
		beq	SPECIAL
		cmpi.b	#'0',d0
		bne	@f
		move.b	#SPACE,-1(a1)
		bra	@b

SPECIAL::
		subq.l	#2,a1
		cmpi.b	#SPACE,(a1)
		bne	@f
		move.b	#'0',(a1)
@@:
	movem.l	(sp)+,d0-d3/a0-a1
	rts

DEC_TABLE::		.dc.w	10000
			.dc.w	1000
			.dc.w	100
			.dc.w	10
			.dc.w	1
			.dc.w	0

**********************************************************
**			Error Routine			**
**********************************************************
USAGE::
	pea.l	USAGE_MSG(pc)
	bra	DISP_ABORT

NOT_XVDDATA::
	pea.l	NOT_XVDDATA_MSG(pc)
	bra	DISP_ABORT

NOT_REV200::
	pea.l	NOT_REV200_MSG(pc)
	bra	DISP_ABORT

NOT_IMAGE_TYPE0::
	pea.l	NOT_IMAGE_TYPE0_MSG(pc)
	bra	DISP_ABORT


IN_NUMBER_ERR::
	pea.l	IN_NUMBER_ERR_MSG(pc)
	bra	DISP_ABORT

NUMBER_OVER::
	pea.l	NUMBER_OVER_MSG(pc)
	bra	DISP_ABORT

OVER_FLOW_FRAME::
	pea.l	OVER_FLOW_FRAME_MSG(pc)
	bra	DISP_ABORT

OVER_X_NUMBER::
	pea.l	OVER_X_NUMBER_MSG(pc)
	bra	DISP_ABORT

OVER_Y_NUMBER::
	pea.l	OVER_Y_NUMBER_MSG(pc)
	bra	DISP_ABORT

END_FRAME_OVER_START_FRAME::
	pea.l	END_FRAME_OVER_START_FRAME_MSG(pc)
	bra	DISP_ABORT

START_FRAME_OVER::
	pea.l	START_FRAME_OVER_MSG(pc)
	bra	DISP_ABORT

END_FRAME_OVER::
	pea.l	END_FRAME_OVER_MSG(pc)
	bra	DISP_ABORT

**********************************************************
**			DOS CALL ERROR			**
**********************************************************
OPEN_ERROR::
	pea.l	OPEN_ERR_MSG(pc)
	bra	DISP_ABORT

MALLOC_ERROR::
	pea.l	MALLOC_ERROR_MSG(pc)
	bra	DISP_ABORT

SEEK_ERROR::
	pea.l	SEEK_ERR_MSG(pc)
	bra	DISP_ABORT

WRITE_ERROR::
	pea.l	WRITE_ERR_MSG(pc)
	bra	DISP_ABORT

READ_ERROR::
	pea.l	READ_ERR_MSG(pc)
*	bra	DISP_ABORT

DISP_ABORT::
	DOS	_PRINT			*$FF09
	addq.l	#4,sp

END:
	DOS	_EXIT


	.data
	.even

**********************************************************
**			DATA ARIA			**
**********************************************************
USAGE_MSG::
	.dc.b	'.xvd Easy Frame Viewer 2 ver0.76  Oct 30 1998 FunaPon',CR,LF
	.dc.b	CR,LF
	.dc.b	'usage : xvdfv2 <option> xvdfile',CR,LF
	.dc.b	'option: -f[num] : num = frame number (0n65535)',CR,LF
	.dc.b	'      : -a[x,y] : x,y = load point',CR,LF
	.dc.b	'      : -a      : One Frame Only load',CR,LF
	.dc.b	'      : -3      : SVDFV3 Mode',CR,LF
	.dc.b	'      : -v      : View Mode',CR,LF
	.dc.b	'      : -s[num] : num = View Start frame number (0n65535)',CR,LF
	.dc.b	'      : -e[num] : num = View End   frame number (0n65535)',CR,LF,0

OPEN_ERR_MSG::		.dc.b	'DOS _OPEN Error!',CR,LF,0
MALLOC_ERROR_MSG::	.dc.b	'DOS _MALLOC Error!',CR,LF,0
SEEK_ERR_MSG::		.dc.b	'DOS _SEEK Error!',CR,LF,0
READ_ERR_MSG::		.dc.b	'DOS _READ Error!',CR,LF,0
WRITE_ERR_MSG::		.dc.b	'DOS _WRITE Error!',CR,LF,0

NOT_XVDDATA_MSG::	.dc.b	'This File is not XVDfile.',CR,LF,0
NOT_REV200_MSG::	.dc.b	'This File is not rev2.00.',CR,LF,0
NOT_IMAGE_TYPE0_MSG::	.dc.b	'This File is not Type 0.',CR,LF,0

IN_NUMBER_ERR_MSG::	.dc.b	'Option Number Error!',CR,LF,0
NUMBER_OVER_MSG::	.dc.b	'Frame Number is Over!',CR,LF,0
OVER_FLOW_FRAME_MSG::	.dc.b	'Over Frame: -f[n] : 0n65536',CR,LF,0 
OVER_X_NUMBER_MSG::	.dc.b	'Over X Number: 0x+X_length511',CR,LF,0
OVER_Y_NUMBER_MSG::	.dc.b	'Over Y Number: 0y+Y_Length511',CR,LF,0

END_FRAME_OVER_START_FRAME_MSG::
			.dc.b	'-s[num]  -e[num] Error!',CR,LF,0
START_FRAME_OVER_MSG::	.dc.b	'-s[num]  Total frame Error!',CR,LF,0
END_FRAME_OVER_MSG::	.dc.b	'-e[num]  Total frame Error!',CR,LF,0

KEISOKU::		.dc.b	'v',0
WHITE::			.dc.b	'           ',0
FPS::			.dc.b	'fps',0

	.even

TEXT_MASK::		.dc.w	3
			.dc.w	512
			.dc.w	0
			.dc.w	256
			.dc.w	512
			.dc.w	$ffff

TEXT_MASK_CLR::		.dc.w	3
			.dc.w	512
			.dc.w	0
			.dc.w	256
			.dc.w	512
			.dc.w	0

TEXT_PALET::						*3210
			.dc.w	$0			*0000	MARK
			.dc.w	$1			*0001	wi
			.dc.w	$ffff			*0011	wi
			.dc.w	$ffff			*0010	
			.dc.w	$1			*0100	BOX
			.dc.w	$1			*0101
			.dc.w	$1			*0110
			.dc.w	$1			*0111
			.dc.w	$1			*1000	}XN
			.dc.w	$ffff			*1001
			.dc.w	$ffff			*1010
			.dc.w	$ffff			*1011
			.dc.w	$de6c			*1100
			.dc.w	$ffff			*1101
			.dc.w	$ffff			*1110

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
